/**********************************************************************

	Command:    DDFRAME, a dialog based frame creator/maintainer

	Programmed by Kang, Hsin-Min.
	Released at Aug 15, 1998 Initial Release
	Revised at Aug 27, 1998  Optimize for speed in loading TBX file
				 by introducing the TBZ file. The speed
				 to generate the preview plotting is also
				 optimized.
	Revised at Aug 29, 1998  Change layout and Add Block creation.
	Revised at Sep 03, 1998  Fix such that margin is compensatedz
	Revised at Oct 07, 1998  Modify to use user specified layer/color
	Revised at Oct 14, 1998  Add JIS standard papers
	Revised at Oct 15, 1998  Japenese Message Texts Translation

	Copyright (c) 1998 TCAM Development House, Taipei
	All rights Reserved.

	Status: TwinCAD Standard Command, with full support from
		TCAM Development House.

  Commants:

***********************************************************************/
#define MYVERSION	1.0
#define TBZVERSION	1

#define MAXFIELD	256
#define MAXTAG		256
#define MAXFDCHAR	12
#define MAXTAGCHAR	16
#define MAXTEXTCHAR	72
#define MAXBOX		64
#define MAXBOXCHAR	12
#define MAXLINE 	128
#define MAXFIDX 	256
#define MAXNESTIF	16
#define MAXTDEF 	128

#define BOOL	int
#define TRUE	1
#define FALSE	0
#define EOF	-1

#define TPA_KEY "80FF04019EC2"  /* TPA key assigned for DDFRAME command */

#define MARKON	0x8000		/* DOS version compatible marking value */
#define MARKOFF 0x80ff		/* DOS version compatible marking value */
#define FTEXT	0x40
#define DEBUG	0

#define OBM_COMBO	"#32738"

#define BIG5		0x404
#define GB2312		0x804
#define SJIS		0x411
#define KOREAN		0x412
#define ASCII		0x409

#define DOEXIT	0
#define DODRAW	1
#define DOPICK	2
//
#define FILEMAGICID	0x1a434241L
#define DATAFILE	fullname("DDFRAME.SET",get_syspath(0))

#define MAXTBX		128
#define MAXTBXCHAR	40
#define MAXTBXPATH	80
//
char	szBtn[16][10];	// For all common buttons (8 chars)
char	szText[50][60]; // Our display text buffer, see SetMsgText()
			// at the end of this file
int	nTBX;
char	szTBX[MAXTBX][MAXTBXCHAR];
char	szTBXPath[MAXTBX][MAXTBXPATH];
//
//	Do we have direct support of some new TCL functions...
//
int	nSupport=identify("wnd_resize");
int	IsWin;		// Is Windows Version?

#define MAXSTD	6
#define ANSI	0
#define CNS	1
#define DIN	2
#define ISO	3
#define JIS	4
#define USER	5

#define TAGDISP 0x2000
#define TAGVAR	0x4000

#define TBXMARGIN	1
#define TBXBORDER	2
#define TBXDOUBLE	4
#define TBXMARKER	8
#define TBXGAP		0x10
#define TBXSCALE	0x10

int	nStd=0;
int	nPaper[MAXSTD]={0,0,0,0,0};
double	dXsize, dYsize;
char	szPivot[][12]={"None","Points","Lines","Box",""};
char	szPaperName[40];
char	szStd[MAXSTD][12]={"ANSI","CNS","DIN","ISO","JIS","User"};
#define MAXANSI 5
char	szAnsi[][12]={
"A-Size",// 268,203
"B-Size",// 406,254
"C-Size",// 533,406
"D-Size",// 838,533
"E-Size",// 1092,838
""
};

int	nxAnsi[MAXANSI]={268,406,533,838,1092};
int	nyAnsi[MAXANSI]={203,254,406,533,838};
double	dMAnsi[MAXANSI][4];
double	dWAnsi[MAXANSI][3];
double	dTAnsi[MAXANSI];
double	dGAnsi[MAXANSI];
double	dSAnsi[MAXANSI];
int	nHAnsi[MAXANSI];
int	nVAnsi[MAXANSI];
int	nFAnsi[MAXANSI];

#define MAXCNS	8
char	szCns[][12]={
"A0",// 1189,840
"A1",// 840,586
"A2",// 586,420
"A3",// 420,297
"A4",// 297,210
"A4-P",// 297,210
"A5",  // 210,148
"A5-P",// 210,148
""
};

int	nxCns[MAXCNS]={1189,841,594,420,297,210,210,148};
int	nyCns[MAXCNS]={ 841,594,420,297,210,297,148,210};
double	dMCns[MAXCNS][4];
double	dWCns[MAXCNS][3];
double	dTCns[MAXCNS];
double	dGCns[MAXCNS];
double	dSCns[MAXCNS];
int	nHCns[MAXCNS];
int	nVCns[MAXCNS];
int	nFCns[MAXCNS];

#define MAXISO	8
char	szIso[][12]={
"A0",// 1189,840
"A1",// 840,586
"A2",// 586,420
"A3",// 420,297
"A4",// 297,210
"A4-P",// 297,210
"A5",  // 210,148
"A5-P",// 210,148
""
};

int	nxIso[MAXISO]={1189,840,586,420,297,210,210,148};
int	nyIso[MAXISO]={ 840,586,420,297,210,297,148,210};
double	dMIso[MAXISO][4];
double	dWIso[MAXISO][3];
double	dTIso[MAXISO];
double	dGIso[MAXISO];
double	dSIso[MAXISO];
int	nHIso[MAXISO];
int	nVIso[MAXISO];
int	nFIso[MAXISO];

#define MAXDIN	8
char	szDin[][12]={
"A0",// 1189,840
"A1",// 840,586
"A2",// 586,420
"A3",// 420,297
"A4",// 297,210
"A4-P",// 297,210
"A5",  // 210,148
"A5-P",// 210,148
""
};
int	nxDin[MAXDIN]={1189,840,586,420,297,210,210,148};
int	nyDin[MAXDIN]={ 840,586,420,297,210,297,148,210};
double	dMDin[MAXDIN][4];
double	dWDin[MAXDIN][3];
double	dTDin[MAXDIN];
double	dGDin[MAXDIN];
double	dSDin[MAXDIN];
int	nHDin[MAXDIN];
int	nVDin[MAXDIN];
int	nFDin[MAXDIN];

#define MAXJIS	15
char	szJis[][12]={
"A0x2",// 1682,1189
"A0",  // 1189,841
"A1x3",// 1783,841
"A1",  // 841, 594
"A2x3",// 1261, 594
"A2x4",// 1682, 594
"A2",  // 586,420
"A3x3",// 891,420
"A3x4",// 1189,420
"A3",  // 420,297
"A4x3",// 630,297
"A4x4",// 841,297
"A4x5",// 1051,297
"A4",  // 297,210
"A4-P",// 210,297
""
};

int	nxJis[MAXJIS]={
	1682,	1189,	1783,	841,	1261,	1682,	586,	891,
	1189,	420,	630,	841,	1051,	297,	210
};
int	nyJis[MAXJIS]={
	1189,	841,	841,	594,	594,	594,	420,	420,
	420,	297,	297,	297,	297,	210	297
};
double	dMJis[MAXJIS][4];
double	dWJis[MAXJIS][3];
double	dTJis[MAXJIS];
double	dGJis[MAXJIS];
double	dSJis[MAXJIS];
int	nHJis[MAXJIS];
int	nVJis[MAXJIS];
int	nFJis[MAXJIS];

double	dMargin[4]={10,10,10,10};     // Left/top/right/bottom
int	nMark=1;
int	nType=0;	// Frame type
int	nHori=1;
int	nVert=0;
int	nHdiv=16;
int	nVdiv=10;
int	nUseTBX=1;
int	nTBXidx=0;
int	nPivot=1;
char	szTBXName[40]="";
int	nEdited=0;
int	nHasCond=0;
int	nHasCal=0;
int	nBlock=0;
POINT	pOfst={0,0};
char	szBname[80];

double	dWidth[3]={0.,1.0,0.5};
double	dTh=5;
double	dTgap=1.;
double	dTscale=1.0;
double	dScale=1.0;

int	widMain;	// Main Dialog Window ID
int	widVport;	// Sub Window for text view port
int	nMain[6]={1,24,2,72,0x3270,0x8000};
int	nVport[5]={6,10,30,59,0x32f7};
int	nTatrb=0x270;
int	nSatrb=0x270;

long	lSizeTbx;	// Current size of loaded TBX, for checking only
long	lDateTbx;	// Current date of loaded TBX, for checking only

int	nField;
char	szField[MAXFIELD][MAXFDCHAR];
char	szFText[MAXFIELD][MAXTEXTCHAR];
char	szTagText[MAXFIELD][MAXTEXTCHAR];
int	nFRef[MAXFIELD];
int	nTagID[MAXFIELD];
int	nTadj[MAXFIELD];
int	nWtext[MAXFIELD];

int	nEntry;
int	nEntryID[MAXFIELD];

int	nTag;
char	szTag[MAXTAG][MAXTAGCHAR];
int	nTagAtrb[MAXTAG];
char	szTagPrompt[MAXFIELD][MAXTEXTCHAR];

int	nBox;
char	szBox[MAXBOX][MAXBOXCHAR];
int	nAncho[MAXBOX];
int	nAnchoID[MAXBOX];
int	nBH[MAXBOX];
int	nBW[MAXBOX];
int	nBLink[MAXBOX];
double	dBH[MAXBOX];

int	nLine;
int	nLNext[MAXLINE];
int	nLLink[MAXLINE];
int	nLH[MAXLINE];

int	nFidx;
int	nFNext[MAXFIDX];
int	nFID[MAXFIDX];
int	nFW[MAXFIDX];
double	dFW[MAXFIDX];
//
int	nTdef;
double	dTlen[MAXTDEF];
ENTITY	eTdef[MAXTDEF];
//
COMMAND DDFRAME()
{
	IsWin = 1;
	switch(1) {  // Test if we are in TwinCAD ...
	  case !identify("os_type"):
	  case (os_type()<0):	// Must be in DOS version!
		IsWin = 0;
		break;
	}
	if ( !IsWin ) { 	// For DOS
		nMain[0] |= 0x800;
		nMain[2] = 5;
		nTatrb = 0x2f0;
	}
	SetMsgText();
	LoadSetup();
	UpdatePaper(0);
	if ( nTBX == 0 ) FindAllTBX();
	if ( nTBX ) LoadTBX(szTBXPath[nTBXidx]);
	for(;;) {
	    switch(DoDialog()) {
	      case DODRAW: DrawIt(); break;
	      case DOPICK: PickPos(); continue;
	    }
	    break;
	}
}

void	PickPos()
{
	pOfst = getp(szText[42]/*"\nDesignate paper frame base position: "*/,pOfst);
}

void	DrawIt()
{
	double	ds, dts, dg;
	ENTITY	eStart, eBlock;
	SLIST	slist;
	int	i;
	int	cmdecho=@cmdecho;
	double	dM[4];

	setdata(dM,dMargin);
	if ( nType && (dWidth[1]<0) ) { 	// Compensate it
		dMargin[0] -= dWidth[1];
		dMargin[1] -= dWidth[1];
		dMargin[2] -= dWidth[1];
		dMargin[3] -= dWidth[1];
	}
	set_undo(0);	// Regen when redo
	ds = dScale;
	eStart = ent_last();
	nTdef = 0;
	if ( nBlock & 1 ) {
		dScale = 1;
		szBname = upper(szStd[nStd]);
		switch(nStd) {
		  case USER:
			szBname += prints("-%dx%d",ifix(GetXsize()),ifix(GetYsize()));
			break;
		  case ANSI:
			szBname += "-"+left$(szPaperName,1);
			break;
		  default:
			szBname += "-"+szPaperName;
			break;
		}
		//
		// We need to check if the block name already exist
		//
	}
	DrawFrame();
	if ( nMark & 1 ) MarkFrame();
	if ( (nUseTBX&1) && szTBXName!="" && nTBX ) {
		if ( !nEdited && nEntry ) FieldEntry();
		dg = dTgap;
		dts = dTscale;
		if ( dTgap > 0 ) dTgap *= dScale;
		dTscale *= dScale;
		DrawTBX(0);
		dTscale = dts;
		dTgap = dg;
	}
	dScale = ds;
	@cmdecho = 0;
	if ( nBlock & 1 ) {
		set_undo(0);	// Regen when redo
		if ( ent_ok(eStart) ) eStart = ent_next(eStart);
		else		      eStart = ent_next();
		slist = getesel(eStart);
		eBlock = block(szBname,pOfst,slist);
		for(i=0;i<nTdef;i++) AdjTag(eTdef[i],dTlen[i]);
		//
		//  We need to add an addtional space or ^M to suppress
		//  the default local tag edit dialog window...
		//
		command("INSERT "+szBname+" \@pOfst \@dScale ^M0^M^M");
		p1 = (@LIMMIN-pOfst)*dScale+pOfst;
		p2 = (@LIMMAX-pOfst)*dScale+pOfst;
		command("LIMITS p1 p2^M");
	}
	command("ze");
	@cmdecho = cmdecho;
	set_undo(0);	// Regen when redo
	setdata(dMargin,dM);
}
//
//	AdjTag: Adjust tag for fitting requirements, simplified version
//
void	AdjTag(ENTITY eTag, double tdist)
{
	double	a, b, c;
	ENTDATA data;

	data = ent_read(eTag);
//
//	Reset default text style condition here
//
	@TXTWIDTHF = 0;
	@TXTHEIGHT = data.tag.height;
	@TXTOBANGLE = 0;
	@TXTCSPACE = 0;
	@TXTROTCCW = 0;
	data.tag.csp = 0;
	data.tag.width = 1;

	a = text_span(data.tag.str);
	if ( data.tag.tadj == 0x300 ) {        // Even fit
		if ( tdist > a ) {	// Have room!
			@TXTCSPACE = 1;
			b = text_span(data.tag.str);
			@TXTCSPACE = 0;
			c = b-a-1;
			if ( c > 0 ) data.tag.csp = (tdist-a)/c;
			else	     data.tag.csp = 0;
			ent_write(eTag,data);
			return;
		}
		// fall down for fitting
	}
	else {	    // Simple Fitting
		data.tag.tadj = 0x200;
	}
	data.tag.width = tdist/a;
	ent_write(eTag,data);
}

void	UpdatePreview()
{
	double	dM[4];

	setdata(dM,dMargin);
	if ( nType && (dWidth[1]<0) ) { 	// Compensate it
		dMargin[0] -= dWidth[1];
		dMargin[1] -= dWidth[1];
		dMargin[2] -= dWidth[1];
		dMargin[3] -= dWidth[1];
	}

	v1 = GetXsize();
	v2 = GetYsize();

	wnd_select(widVport);
	wnd_vport(-1);
	wnd_vport(0,p(0,0),p(v1,v2),1);

	setplot(7,0,0,0);
	p1 = p(0,0);
	p3 = p(v1,v2);
	p2 = p3.x,p1.y;
	p4 = p1.x,p3.y;
	plotent(L(p1,p2),L(p2,p3),L(p3,p4),L(p4,p1));
	setplot(1,0,0,0);
	PlotFrame();
	if ( nMark & 1 ) PlotMark();
	if ( (nUseTBX&1) && szTBXName!="" && nTBX )
		DrawTBX(1);

	wnd_vport(-1);
	wnd_select(widMain);
	setdata(dMargin,dM);
}

void	PlotFrame()
{
	p1 = p(dMargin[0],dMargin[3]);
	p3 = p(GetXsize(),GetYsize())-p(dMargin[2],dMargin[1]);
	p2 = p3.x,p1.y;
	p4 = p1.x,p3.y;
	plotent(L(p1,p2),L(p2,p3),L(p3,p4),L(p4,p1));
	if ( nType ) {
		p5 = p(dWidth[1],dWidth[1]);
		p1 += p5;
		p3 -= p5;
		p5.x = -p5.x;
		p2 += p5;
		p4 -= p5;
		plotent(L(p1,p2),L(p2,p3),L(p3,p4),L(p4,p1));
	}
}

void	PlotMark()
{
	int	i;
	double	dlen;
	POINT	pBase, pNext, pDelta;

	v1 = GetXsize();
	v2 = GetYsize();
	p1 = p(dMargin[0],dMargin[3]);
	p2 = p(GetXsize(),GetYsize())-p(dMargin[2],dMargin[1]);
	dlen = dTh/2;
	if ( nHdiv <= 0 ) nHdiv = 12;
	pDelta = p((p2.x-p1.x)/nHdiv,0);
	pBase = p(p1.x,p2.y);
	for(i=1;i<nHdiv;i++) {
		pNext = pBase+pDelta*i;
		plotent(L(pNext,pNext+p(0,dlen)));
	}
	pBase = p(p1.x,p1.y);
	for(i=1;i<nHdiv;i++) {
		pNext = pBase+pDelta*i;
		plotent(L(pNext,pNext-p(0,dlen)));
	}
	if ( nVdiv <= 0 ) nVdiv = 8;
	pDelta = p(0,-(p2.y-p1.y)/nVdiv);
	pBase = p(p1.x,p2.y);
	for(i=1;i<nVdiv;i++) {
		pNext = pBase+pDelta*i;
		plotent(L(pNext,pNext-p(dlen,0)));
	}
	pBase = p(p2.x,p2.y);
	for(i=1;i<nVdiv;i++) {
		pNext = pBase+pDelta*i;
		plotent(L(pNext,pNext+p(dlen,0)));
	}

	@TXTHEIGHT = dTh;

	pDelta = p((p2.x-p1.x)/nHdiv,0);
	pBase = p(p1.x,p2.y);
	pNext = pDelta/2+p(0,dTh/5);
	for(i=0;i<nHdiv;i++) {
		p3 = pBase+pDelta*i+pNext;
		if ( nHori )	plotent(prints("%c",i+'A'),p3,0);
		else		plotent(prints("%d",i+1),p3,0);
	}
	pBase = p(p1.x,p1.y);
	pNext = pDelta/2-p(0,6*dTh/5);
	for(i=0;i<nHdiv;i++) {
		p3 = pBase+pDelta*i+pNext;
		if ( nHori )	plotent(prints("%c",i+'A'),p3,0);
		else		plotent(prints("%d",i+1),p3,0);
	}
	pDelta = p(0,-(p2.y-p1.y)/nVdiv);
	pBase = p(p1.x,p2.y);
	pNext = pDelta/2-p(6*dTh/5,0);
	for(i=0;i<nVdiv;i++) {
		p3 = pBase+pDelta*i+pNext;
		if ( nVert )	plotent(prints("%c",i+'A'),p3,0);
		else		plotent(prints("%d",i+1),p3,0);
	}
	pBase = p(p2.x,p2.y);
	pNext = pDelta/2+p(2*dTh/5,0);
	for(i=0;i<nVdiv;i++) {
		p3 = pBase+pDelta*i+pNext;
		if ( nVert )	plotent(prints("%c",i+'A'),p3,0);
		else		plotent(prints("%d",i+1),p3,0);
	}
}

void	DrawFrame()
{
	int	cmdecho=@cmdecho;

	@cmdecho = 0;		// Turn off echo, faster
//	@curlayer = 0;		// Layer 0
//	@curcolor = -1; 	// By Layer
	@curltype = 0;		// Continuous

	v1 = GetXsize();
	v2 = GetYsize();
	p1 = p(0,0)+pOfst;
	p2 = p(v1,v2)*dScale+pOfst;
	switch(nPivot) {
	  case 1:	// POINTs
		command("POINT p1^M");  // Set pivot point
		command("POINT p2^M");  // Set pivot point
		break;
	  case 2:
		p3 = p1.x,p2.y;
		p4 = p2.x,p1.y;
		newent(L(p1,p1+p(dMargin[0]*dScale,0)),L(p1,p1+p(0,dMargin[3]*dScale)));
		newent(L(p2,p2-p(dMargin[2]*dScale,0)),L(p2,p2-p(0,dMargin[1]*dScale)));
		newent(L(p3,p3+p(dMargin[0]*dScale,0)),L(p3,p3-p(0,dMargin[1]*dScale)));
		newent(L(p4,p4-p(dMargin[2]*dScale,0)),L(p4,p4+p(0,dMargin[3]*dScale)));
		break;
	  case 3:
		command("BOX p1 p2^M");
		break;
	}

	p1 = p(dMargin[0],dMargin[3])*dScale+pOfst;
	p2 = (p(GetXsize(),GetYsize())-p(dMargin[2],dMargin[1]))*dScale+pOfst;
	command("BOX p1 p2^M");
	command("LIMITS p1 p2^M");
	if ( dWidth[0] != 0. ) command("SETWIDTH \@dWidth[0]*\@dScale ent_last() ^M^M");
	if ( nType ) {
		p3 = p1+p(dWidth[1],dWidth[1])*dScale;
		p4 = p2-p(dWidth[1],dWidth[1])*dScale;
		command("BOX p3 p4^M");
		if ( dWidth[2] != 0. ) command("SETWIDTH \@dWidth[2]*\@dScale ent_last() ^M^M");
	}
	@cmdecho = cmdecho;	// Restore echo
}

void	MarkFrame()
{
	int	cmdecho=@cmdecho;
	int	i, cadj;
	double	dlen, dt;
	POINT	pBase, pNext, pDelta;

	@cmdecho = 0;		// Turn off echo, faster
//	@curlayer = 0;		// Layer 0
//	@curcolor = -1; 	// By Layer
	@curltype = 0;		// Continuous

	e1 = ent_last();

	p1 = p(dMargin[0],dMargin[3])*dScale+pOfst;
	p2 = (p(GetXsize(),GetYsize())-p(dMargin[2],dMargin[1]))*dScale+pOfst;
	dt = dTh;
	dTh *= dScale;
	dlen = dTh/2;
	cadj = 0;
	if ( dWidth[1] < 0 ) {
		if ( dlen < abs(dWidth[1])) {
			dlen = abs(dWidth[1]);
			cadj = 1;
		}
	}
	if ( nHdiv <= 0 ) nHdiv = 12;
	pDelta = p((p2.x-p1.x)/nHdiv,0);
	pBase = p(p1.x,p2.y);
	for(i=1;i<nHdiv;i++) {
		pNext = pBase+pDelta*i;
		newent(L(pNext,pNext+p(0,dlen)));
	}
	pBase = p(p1.x,p1.y);
	for(i=1;i<nHdiv;i++) {
		pNext = pBase+pDelta*i;
		newent(L(pNext,pNext-p(0,dlen)));
	}
	if ( nVdiv <= 0 ) nVdiv = 8;
	pDelta = p(0,-(p2.y-p1.y)/nVdiv);
	pBase = p(p1.x,p2.y);
	for(i=1;i<nVdiv;i++) {
		pNext = pBase+pDelta*i;
		newent(L(pNext,pNext-p(dlen,0)));
	}
	pBase = p(p2.x,p2.y);
	for(i=1;i<nVdiv;i++) {
		pNext = pBase+pDelta*i;
		newent(L(pNext,pNext+p(dlen,0)));
	}
	if ( dWidth[0]!=0.)
		command("setwidth \@dWidth[0]*\@dScale M getesel(ent_next(e1)) ^M^M");

	pDelta = p((p2.x-p1.x)/nHdiv,0);
	pBase = p(p1.x,p2.y);
	if ( cadj ) {
		pNext = pDelta/2+p(0,dlen/2);
		for(i=0;i<nHdiv;i++) {
			p3 = pBase+pDelta*i+pNext;
			if ( nHori )	command(prints("TEXT J HC^Mp3 \@dTh 0 %c^M^M",i+'A'));
			else		command(prints("TEXT J HC^Mp3 \@dTh 0 %d^M^M",i+1));
		}
	}
	else {
		pNext = pDelta/2+p(0,dTh/5);
		for(i=0;i<nHdiv;i++) {
			p3 = pBase+pDelta*i+pNext;
			if ( nHori )	command(prints("TEXT J C^Mp3 \@dTh 0 %c^M^M",i+'A'));
			else		command(prints("TEXT J C^Mp3 \@dTh 0 %d^M^M",i+1));
		}
	}
	pBase = p(p1.x,p1.y);
	if ( cadj ) {
		pNext = pDelta/2-p(0,dlen/2);
		for(i=0;i<nHdiv;i++) {
			p3 = pBase+pDelta*i+pNext;
			if ( nHori )	command(prints("TEXT J HC^Mp3 \@dTh 0 %c^M^M",i+'A'));
			else		command(prints("TEXT J HC^Mp3 \@dTh 0 %d^M^M",i+1));
		}
	}
	else {
		pNext = pDelta/2-p(0,dTh/5);
		for(i=0;i<nHdiv;i++) {
			p3 = pBase+pDelta*i+pNext;
			if ( nHori )	command(prints("TEXT J TC^Mp3 \@dTh 0 %c^M^M",i+'A'));
			else		command(prints("TEXT J TC^Mp3 \@dTh 0 %d^M^M",i+1));
		}
	}
	pDelta = p(0,-(p2.y-p1.y)/nVdiv);
	pBase = p(p1.x,p2.y);
	if ( cadj ) {
		pNext = pDelta/2-p(dlen/2,0);
		for(i=0;i<nVdiv;i++) {
			p3 = pBase+pDelta*i+pNext;
			if ( nVert )	command(prints("TEXT J HC^Mp3 \@dTh 0 %c^M^M",i+'A'));
			else		command(prints("TEXT J HC^Mp3 \@dTh 0 %d^M^M",i+1));
		}
	}
	else {
		pNext = pDelta/2-p(dTh/5,0);
		for(i=0;i<nVdiv;i++) {
			p3 = pBase+pDelta*i+pNext;
			if ( nVert )	command(prints("TEXT J HR^Mp3 \@dTh 0 %c^M^M",i+'A'));
			else		command(prints("TEXT J HR^Mp3 \@dTh 0 %d^M^M",i+1));
		}
	}
	pBase = p(p2.x,p2.y);
	if ( cadj ) {
		pNext = pDelta/2+p(dlen/2,0);
		for(i=0;i<nVdiv;i++) {
			p3 = pBase+pDelta*i+pNext;
			if ( nVert )	command(prints("TEXT J HC^Mp3 \@dTh 0 %c^M^M",i+'A'));
			else		command(prints("TEXT J HC^Mp3 \@dTh 0 %d^M^M",i+1));
		}
	}
	else {
		pNext = pDelta/2+p(dTh/5,0);
		for(i=0;i<nVdiv;i++) {
			p3 = pBase+pDelta*i+pNext;
			if ( nVert )	command(prints("TEXT J HL^Mp3 \@dTh 0 %c^M^M",i+'A'));
			else		command(prints("TEXT J HL^Mp3 \@dTh 0 %d^M^M",i+1));
		}
	}
	dTh = dt;
	@cmdecho = cmdecho;	// Restore echo
}

int	bStd, bPaper, bSize, bBlock, bOfst;
int	bMargin, bType, bWidth, bTh, bMark;
int	bHori, bHdiv, bVert, bVdiv, bScale, bPivot;
int	bUseTBX, bTBXName, bTBXScale, bTBXGap;
int	bCancel, bHelp, bEdit, bScan, bDefault;
int	bOk;
int	DoDialog()
{
	int	nBtn;
	int	nRet;
	int	nID, i,j;
	char	szName[80];

	OpenDialog();
	UpdateDialog();
	nRet = DOEXIT;
	for(;;) {
		nBtn = wnd_gbtn(0);
		switch(nBtn) {
		  case -3:
		  case -2:
		  case -1:
		  case bCancel:
		  case	0:	break;
		  case bOk:
			nRet = DODRAW;
			break;
		  case bStd:
		  case bStd+1:
			szName = szPaperName;
			i = nStd;
			nStd = wnd_fgeto(bStd,szStd,0xf0,8,nStd);
			UpdatePaper(1);
			if ( (szPaperName != szName) && nHasCond ) {
				if ( !ReloadTBX() ) {
					nStd = i;
					UpdatePaper(1);
					continue;
				}
			}
			UpdatePreview();
			continue;
		  case bPaper:
		  case bPaper+1:
			if ( nStd == USER ) {
				beep();
				continue;
			}
			szName = szPaperName;
			i = nPaper[nStd];
			if ( nStd == ANSI )	nPaper[nStd] = wnd_fgeto(bPaper,szAnsi,0xf0,8,i);
			else if ( nStd == CNS ) nPaper[nStd] = wnd_fgeto(bPaper,szCns,0xf0,8,i);
			else if ( nStd == ISO ) nPaper[nStd] = wnd_fgeto(bPaper,szIso,0xf0,8,i);
			else if ( nStd == JIS ) nPaper[nStd] = wnd_fgeto(bPaper,szJis,0xf0,8,i);
			else if ( nStd == DIN ) nPaper[nStd] = wnd_fgeto(bPaper,szDin,0xf0,8,i);
			else { beep();	continue; }
			UpdatePaper(1);
			if ( (szPaperName != szName) && nHasCond ) {
				if ( !ReloadTBX() ) {
					nPaper[nStd] = i;
					UpdatePaper(1);
					continue;
				}
			}
			UpdatePreview();
			continue;
		  case bSize:
			i = wnd_fgetd(nBtn,6,0x2e0,GetXsize());
			if ( i != GetXsize() ) {
				dXsize = i;
				dYsize = GetYsize();
				nStd = USER;
				UpdatePaper(1);
				UpdatePreview();
			}
			continue;
		  case bSize+1:
			i = wnd_fgetd(nBtn,6,0x2e0,GetYsize());
			if ( i != GetYsize() ) {
				dXsize = GetXsize();
				dYsize = i;
				nStd = USER;
				UpdatePaper(1);
				UpdatePreview();
			}
			continue;
		  case bMargin:
		  case bMargin+1:
		  case bMargin+2:
		  case bMargin+3:
			i = nBtn-bMargin;
			dMargin[i] = wnd_fgetd(nBtn,6,0x2e0,dMargin[i]);
			wnd_ftext(nBtn,prints("%6.1f",dMargin[i]),nTatrb);
			UpdatePreview();
			continue;
		  case bWidth:
		  case bWidth+1:
		  case bWidth+2:
			i = nBtn-bWidth;
			dWidth[i] = wnd_fgetd(nBtn,5,0x2e0,dWidth[i]);
			wnd_ftext(nBtn,prints("%5.2f",dWidth[i]),nTatrb);
			UpdatePreview();
			continue;
		  case bType: case bType+1:
			nType = nBtn - bType;
			SetRadioMark(bType,bType+1,nType);
			UpdBtnState(1);
			UpdatePreview();
			continue;
		  case bHori: case bHori+1:
			nHori = nBtn - bHori;
			SetRadioMark(bHori,bHori+1,nHori);
			UpdatePreview();
			continue;
		  case bVert: case bVert+1:
			nVert = nBtn - bVert;
			SetRadioMark(bVert,bVert+1,nVert);
			UpdatePreview();
			continue;
		  case bHdiv:
			nHdiv = wnd_fgetd(nBtn,3,0x2e0,nHdiv);
			if ( nHdiv <= 0 ) nHdiv = 12;
			wnd_ftext(nBtn,prints("%3d",nHdiv),nTatrb);
			UpdatePreview();
			continue;
		  case bVdiv:
			nVdiv = wnd_fgetd(nBtn,3,0x2e0,nVdiv);
			if ( nVdiv <= 0 ) nVdiv = 8;
			wnd_ftext(nBtn,prints("%3d",nVdiv),nTatrb);
			UpdatePreview();
			continue;
		  case bMark:
			nMark ^= 1;
			wnd_fmark(bMark,0,(nMark&1)?MARKON:MARKOFF);
			UpdBtnState(1);
			UpdatePreview();
			continue;
		  case bUseTBX:
			nUseTBX ^= 1;
			wnd_fmark(bUseTBX,0,(nUseTBX&1)?MARKON:MARKOFF);
			UpdBtnState(1);
			UpdatePreview();
			continue;
		  case bBlock:
			nBlock ^= 1;
			wnd_fmark(bBlock,0,(nBlock&1)?MARKON:MARKOFF);
			continue;
		  case bTh:
			dTh = wnd_fgetd(nBtn,5,0x2e0,dTh);
			if ( dTh <= 0 ) dTh = 5;
			wnd_ftext(nBtn,prints("%5.2f",dTh),nTatrb);
			continue;
		  case bTBXName:
		  case bTBXName+1:
			if ( nTBX == 0 ) {
				beep();
				continue;
			}
			i = nTBXidx;
			nTBXidx = wnd_fgeto(bTBXName,szTBX,0xf0,8,nTBXidx);
			szTBXName = szTBX[nTBXidx];
			wnd_ftext(bTBXName  ,prints("%-20s",szTBXName),nTatrb);
			if ( i!=nTBXidx ) LoadTBX(szTBXPath[nTBXidx]);
			UpdatePreview();
			continue;
		  case bTBXGap:
			dTgap = wnd_fgetd(nBtn,5,0x2e0,dTgap);
			wnd_ftext(nBtn,prints("%5.2f",dTgap),nTatrb);
			continue;
		  case bTBXScale:
			dTscale = wnd_fgetd(nBtn,5,0x2e0,dTscale);
			if ( dTscale <= 0 ) dTscale = 1;
			wnd_ftext(nBtn,prints("%5.2f",dTscale),nTatrb);
			UpdatePreview();
			continue;
		  case bScale:
			dScale = wnd_fgetd(nBtn,5,0x2e0,dScale);
			if ( dScale <= 0 ) dScale = 1;
			wnd_ftext(nBtn,prints("%5.2f",dScale),nTatrb);
			continue;
		  case bPivot:
		  case bPivot+1:
			nPivot = wnd_fgeto(bPivot,szPivot,0xf0,8,nPivot);
			wnd_ftext(bPivot,prints("%-6s",szPivot[nPivot]),nTatrb);
			continue;
		  case bEdit:
			if ( nEntry == 0 ) {
				beep();
				continue;
			}
			FieldEntry();
			continue;
		  case bScan:
			FindAllTBX();
			LoadTBX(szTBXPath[nTBXidx]);
			UpdateDialog();
			continue;
		  case bDefault:
			if ( (nTBX==0) || !(nUseTBX&1) || (nStd==USER) ) {
				beep();
				continue;
			}
			SetDefault();
			UpdateDialog();
			continue;
		  case bOfst:
			pOfst.x = wnd_fgetd(nBtn,7,0x2e0,pOfst.x);
			wnd_ftext(nBtn,prints("%7.2f",pOfst.x),nTatrb);
			continue;
		  case bOfst+1:
			pOfst.y = wnd_fgetd(nBtn,7,0x2e0,pOfst.y);
			wnd_ftext(nBtn,prints("%7.2f",pOfst.y),nTatrb);
			continue;
		  case bOfst+2:
			nRet = DOPICK;
			break;
		  case 0x2308:	// ^H
		  case bHelp:
			show_help("","DDFRAME");
			continue;
		  default:
			continue;
		}
		break;
	}
	wndclose();
	SaveSetup();
	return nRet;
}
//
void	UpdBtnState(int n)
{
	int	i;
	if ( !identify("wnd_state") ) return;

	if ( (nTBX==0) || !(nUseTBX&1) || (nStd==USER) )
		wnd_state(bDefault,1,n);
	else
		wnd_state(bDefault,1,0);
	wnd_state(bUseTBX,1,nTBX?0:n);
	if ( nTBX == 0 || !(nUseTBX&1) ) {
		wnd_state(bTBXName,1,n);
		wnd_state(bTBXName+1,1,n);
		wnd_state(bTBXScale,1,n);
		wnd_state(bTBXGap,1,n);
	}
	else {
		wnd_state(bTBXName,1,0);
		wnd_state(bTBXName+1,1,0);
		wnd_state(bTBXScale,1,0);
		wnd_state(bTBXGap,1,0);
	}
	if ( nMark & 1 ) for(i=bTh;i<=bVdiv;i++) wnd_state(i,1,0);
	else		 for(i=bTh;i<=bVdiv;i++) wnd_state(i,1,n);
	if ( nType ) {
		wnd_state(bWidth+1,1,0);
		wnd_state(bWidth+2,1,0);
	}
	else {
		wnd_state(bWidth+1,1,n);
		wnd_state(bWidth+2,1,n);
	}
}
//
void	SetDefault()
{
	switch(nStd) {
	  case ANSI:	AnsiDefault();	break;
	  case CNS:	CnsDefault();  break;
	  case ISO:	IsoDefault();  break;
	  case JIS:	JisDefault();  break;
	  case DIN:	DinDefault();  break;
	}
}
//
void	AnsiDefault()
{
	int	flag;
	int	idx;
	idx = nPaper[ANSI];
	flag = nFAnsi[idx];
	if ( flag & TBXMARGIN )
		memmove(dMargin,&dMAnsi[idx][0],sizeof(dMargin));
	if ( flag & TBXBORDER ) {
		memmove(dWidth,&dWAnsi[idx][0],sizeof(dWidth));
		nType = (flag&TBXDOUBLE)?1:0;
	}
	if ( flag & TBXMARKER ) {
		nHdiv = abs(nHAnsi[idx]);
		nVdiv = abs(nVAnsi[idx]);
		nHori = (nHAnsi[idx]>0)?0:1;
		nVert = (nVAnsi[idx]>0)?0:1;
		dTh = dTAnsi[idx];
	}
	if ( flag & TBXGAP ) dTgap = dGAnsi[idx];
	if ( flag & TBXSCALE ) dTscale = dSAnsi[idx];
}
//
void	CnsDefault()
{
	int	flag;
	int	idx;
	idx = nPaper[CNS];
	flag = nFCns[idx];
	if ( flag & TBXMARGIN )
		memmove(dMargin,&dMCns[idx][0],sizeof(dMargin));
	if ( flag & TBXBORDER ) {
		memmove(dWidth,&dWCns[idx][0],sizeof(dWidth));
		nType = (flag&TBXDOUBLE)?1:0;
	}
	if ( flag & TBXMARKER ) {
		nHdiv = abs(nHCns[idx]);
		nVdiv = abs(nVCns[idx]);
		nHori = (nHCns[idx]>0)?0:1;
		nVert = (nVCns[idx]>0)?0:1;
		dTh = dTCns[idx];
	}
	if ( flag & TBXGAP ) dTgap = dGCns[idx];
	if ( flag & TBXSCALE ) dTscale = dSCns[idx];
}
//
void	IsoDefault()
{
	int	flag;
	int	idx;
	idx = nPaper[ISO];
	flag = nFIso[idx];
	if ( flag & TBXMARGIN )
		memmove(dMargin,&dMIso[idx][0],sizeof(dMargin));
	if ( flag & TBXBORDER ) {
		memmove(dWidth,&dWIso[idx][0],sizeof(dWidth));
		nType = (flag&TBXDOUBLE)?1:0;
	}
	if ( flag & TBXMARKER ) {
		nHdiv = abs(nHIso[idx]);
		nVdiv = abs(nVIso[idx]);
		nHori = (nHIso[idx]>0)?0:1;
		nVert = (nVIso[idx]>0)?0:1;
		dTh = dTIso[idx];
	}
	if ( flag & TBXGAP ) dTgap = dGIso[idx];
	if ( flag & TBXSCALE ) dTscale = dSIso[idx];
}
//
void	JisDefault()
{
	int	flag;
	int	idx;
	idx = nPaper[JIS];
	flag = nFJis[idx];
	if ( flag & TBXMARGIN )
		memmove(dMargin,&dMJis[idx][0],sizeof(dMargin));
	if ( flag & TBXBORDER ) {
		memmove(dWidth,&dWJis[idx][0],sizeof(dWidth));
		nType = (flag&TBXDOUBLE)?1:0;
	}
	if ( flag & TBXMARKER ) {
		nHdiv = abs(nHJis[idx]);
		nVdiv = abs(nVJis[idx]);
		nHori = (nHJis[idx]>0)?0:1;
		nVert = (nVJis[idx]>0)?0:1;
		dTh = dTJis[idx];
	}
	if ( flag & TBXGAP ) dTgap = dGJis[idx];
	if ( flag & TBXSCALE ) dTscale = dSJis[idx];
}
//
void	DinDefault()
{
	int	flag;
	int	idx;
	idx = nPaper[DIN];
	flag = nFDin[idx];
	if ( flag & TBXMARGIN )
		memmove(dMargin,&dMDin[idx][0],sizeof(dMargin));
	if ( flag & TBXBORDER ) {
		memmove(dWidth,&dWDin[idx][0],sizeof(dWidth));
		nType = (flag&TBXDOUBLE)?1:0;
	}
	if ( flag & TBXMARKER ) {
		nHdiv = abs(nHDin[idx]);
		nVdiv = abs(nVDin[idx]);
		nHori = (nHDin[idx]>0)?0:1;
		nVert = (nVDin[idx]>0)?0:1;
		dTh = dTDin[idx];
	}
	if ( flag & TBXGAP ) dTgap = dGDin[idx];
	if ( flag & TBXSCALE ) dTscale = dSDin[idx];
}
//
//
//	OpenDialog() -- Open main dialog window, create screen items.
//
void	OpenDialog()
{
	int	rBase, cBase, rSave, rSave1;
	int	rInc=0x0401;
	int	cStart;

	cStart = IsWin?2:1;
	widMain = wndopen(nMain,szText[0]/*"Paper Frame Setup"*/,0x3f1f,nMain[5]);
	rBase = 0x0400;
	cBase = cStart;
	WndGroup(rBase,cBase,66,1,szText[1]/*"Paper Dimensions"*/,nSatrb);
	rBase += 0x0001;
	cBase += 1;
	bStd  = WndEntry(rBase+rInc*0,cBase,szText[2]/*"Standard: "*/,0x10a,1);
	bPaper= WndEntry(rBase+rInc*0,cBase+24,szText[3]/*"Paper: "*/,0x10a,1);
	bSize = WndEntry(rBase+rInc*0,cBase+44,szText[4]/*"Size: "*/,0x106,0);
		WndEntry(rBase+rInc*0,cBase+57,"x ",0x106,0);
	rBase += 0x0801;
	cBase = cStart;
	rSave1 = rBase;
	WndGroup(rBase,cBase,38,14,szText[5]/*"Frame Setup"*/,nSatrb);
	rBase += 1;
	cBase += 1;
	rSave = rBase;
	WndGroup(rBase,cBase,16,5|0xfc00,szText[6]/*"Margin"*/,nSatrb);
	rBase += 0x0001;
	cBase += 1;
	bMargin  = WndEntry(rBase+rInc*0,cBase,szText[7] /*"  Left: "*/,0x106,0);
		   WndEntry(rBase+rInc*1,cBase,szText[8] /*"   Top: "*/,0x106,0);
		   WndEntry(rBase+rInc*2,cBase,szText[9] /*" Right: "*/,0x106,0);
		   WndEntry(rBase+rInc*3,cBase,szText[10]/*"Bottom: "*/,0x106,0);
	rBase = rSave;
	cBase += 17;
	WndGroup(rBase,cBase,18,5|0xfc00,szText[11]/*"Border"*/,nSatrb);
	rBase += 0x0001;
	cBase += 1;
	bType	 = WndRadioBox(rBase+rInc*0,cBase,szText[12]/*" Single Line"*/,nSatrb);
		   WndRadioBox(rBase+rInc*1,cBase,szText[13]/*" Double Lines"*/,nSatrb);
	bWidth	 = WndEntry(rBase+rInc*2,cBase,szText[14]/*"1'st Width: "*/,0x105,0);
		   WndEntry(rBase+rInc*3,cBase,"D: ",0x105,0);
		   WndEntry(rBase+rInc*3,cBase+9,"W: ",0x105,0);
	rBase = rBase+0x0805;
	cBase = cStart;
	bPivot	 = WndEntry(rBase,cBase,szText[15]/*"   Pivot: "*/,0x106,1);
	rBase += 0x0801;
	cBase = cStart+1;
	bMark	 = WndCheckBox(rBase,cBase+1,szText[17]/*" Add Marker"*/,nSatrb);
	bTh	 = WndEntry(rBase,cBase+18,szText[18]/*"Text Height: "*/,0x105,0);
	rBase += 0x0401;
	cBase = cStart+1;
	WndGroup(rBase,cBase,36,1,szText[19]/*"Horizontal Partition Markers"*/,nSatrb);
	rBase += 0x0001;
	bHori	 = WndRadioBox(rBase,cBase+1,szText[20]/*"Numbers"*/,nSatrb);
		   WndRadioBox(rBase,cBase+11,szText[21]/*"Alphabets"*/,nSatrb);
	bHdiv	 = WndEntry(rBase,cBase+24,szText[22]/*"Div.#: "*/,0x103,0);
	rBase += 0x0801;
	WndGroup(rBase,cBase,36,1,szText[23]/*"Vertical Partition Markers"*/,nSatrb);
	rBase += 0x0001;
	bVert	 = WndRadioBox(rBase,cBase+1,szText[20]/*"Numbers"*/,nSatrb);
		   WndRadioBox(rBase,cBase+11,szText[21]/*"Alphabets"*/,nSatrb);
	bVdiv	 = WndEntry(rBase,cBase+24,szText[22]/*"Div.#: "*/,0x103,0);

	rBase = rSave1;
	cBase = cStart+40;
	WndGroup(rBase,cBase,26,8,szText[24]/*"Preview"*/,nSatrb);
	nVport[0] = rBase+1;
	nVport[1] = nVport[0]+7;
	nVport[2] = cBase;
	nVport[3] = cBase+25;
	widVport = wndopensub(nVport,0);   // Open sub window for image
	wnd_select(widMain);

	rBase = nVport[1]+0x0801;
	cBase = cStart+40;
	WndGroup(rBase,cBase,26,6,szText[25]/*"TBX Setup"*/,nSatrb);
	rBase += 0x0401;
	cBase += 1;
	bUseTBX  = WndCheckBox(rBase,cBase+1,szText[26]/*" Apply Selected TBX"*/,nSatrb);
	rBase += 0x0200;
	WndGroup(rBase,cBase,22,1,"",nSatrb);
	rBase += 0x0001;
	bTBXName = WndEntry(rBase,cBase,"",0x114,1);
	bScan	 = WndTinyBox(rBase,cBase+23);
	rBase += 0x0400;
	bTBXScale = WndEntry(rBase+rInc*1,cBase,szText[27]/*"Scale: "*/,0x105,0);
	bTBXGap   = WndEntry(rBase+rInc*1,cBase+len(szText[27])+6,
		    szText[28]/*"Gap: "*/,0x105,0);
	rBase += 0x0800;
	bEdit	= WndButton(rBase+rInc*2,cBase+2,0x108,szBtn[8]/*"&TagEdit"*/);
	bDefault= WndButton(rBase+rInc*2,cBase+14,0x108,szBtn[9]/*"&Default"*/);

	rBase += rInc*1+0x0001;
	cBase = cStart;
	WndGroup(rBase,cBase,38,3,"",nSatrb);
	rBase += 0x0401;
	bBlock = WndCheckBox(rBase,cBase+1,szText[40]/*" Create Block"*/,nSatrb);
	bScale = WndEntry(rBase,cBase+19,szText[16]/*"Frame Scale: "*/,0x105,0);
	rBase += 0x0801;
	WndText(rBase,cBase,szText[41]/*"   Frame Location: "*/);
	cBase += 19;
	WndGroup(rBase-1,cBase,18,1,"",nSatrb);
	bOfst =  WndEntry(rBase|0x0100,cBase,"",0x107,0);
		 WndEntry(rBase|0x0100,cBase+9,"",0x107,1);

	rBase = 0x0800+20;
	cBase = cStart+40;
	bOk	= WndButton(rBase,cBase,0x108,szBtn[4]/*"&Create"*/);
	bCancel = WndButton(rBase,cBase+9,0x108,szBtn[3]/*"&Quit"*/);
	bHelp	= WndButton(rBase,cBase+18,0x108,szBtn[2]/*"&Help"*/);
}

double	GetXsize()
{
	int	idx;
	idx = nPaper[nStd];
	switch(nStd) {
	  case ANSI:	return nxAnsi[idx];
	  case CNS:	return nxCns[idx];
	  case ISO:	return nxIso[idx];
	  case JIS:	return nxJis[idx];
	  case DIN:	return nxDin[idx];
	  default:	return dXsize;
	}
}

int	GetYsize()
{
	int	idx;
	idx = nPaper[nStd];
	switch(nStd) {
	  case ANSI:	return nyAnsi[idx];
	  case CNS:	return nyCns[idx];
	  case ISO:	return nyIso[idx];
	  case JIS:	return nyJis[idx];
	  case DIN:	return nyDin[idx];
	  default:	return dYsize;
	}
}

void	UpdatePaper(int n)
{
	int	idx;
	double	xSize, ySize;
	idx = nPaper[nStd];
	switch(nStd) {
	  case ANSI:	szPaperName = szAnsi[idx]; xSize=nxAnsi[idx]; ySize=nyAnsi[idx]; break;
	  case CNS:	szPaperName = szCns[idx]; xSize=nxCns[idx]; ySize=nyCns[idx]; break;
	  case ISO:	szPaperName = szIso[idx]; xSize=nxIso[idx]; ySize=nyIso[idx]; break;
	  case JIS:	szPaperName = szJis[idx]; xSize=nxJis[idx]; ySize=nyJis[idx]; break;
	  case DIN:	szPaperName = szDin[idx]; xSize=nxDin[idx]; ySize=nyDin[idx]; break;
	  default:	szPaperName = "User Size"; xSize=dXsize; ySize = dYsize; break;
	}
	if ( n ) {
		wnd_ftext(bStd,prints("%-10s",szStd[nStd]),nTatrb);
		wnd_ftext(bPaper,prints("%-10s",szPaperName),nTatrb);
		wnd_ftext(bSize,prints("%6.1f",xSize),nTatrb);
		wnd_ftext(bSize+1,prints("%6.1f",ySize),nTatrb);
	}
}
//
//	UpdateDialog() -- Update the content of the main dialog window
//
//	Note:	The use of wnd_fmark to make a check on the checkbox
//		is not fully compatible with DOS version, although
//		the expression: wnd_fmark(n,0,(Check)?0x8000:0x80ff)
//		still works.
//
void	UpdateDialog()
{
	UpdBtnState(0); // Enable all fields before update them
	UpdatePaper(1);
	wnd_ftext(bMargin  ,prints("%6.1f",dMargin[0]),nTatrb);
	wnd_ftext(bMargin+1,prints("%6.1f",dMargin[1]),nTatrb);
	wnd_ftext(bMargin+2,prints("%6.1f",dMargin[2]),nTatrb);
	wnd_ftext(bMargin+3,prints("%6.1f",dMargin[3]),nTatrb);
	SetRadioMark(bType,bType+1,nType);
	SetRadioMark(bHori,bHori+1,nHori);
	SetRadioMark(bVert,bVert+1,nVert);
	wnd_ftext(bHdiv,prints("%3d",nHdiv),nTatrb);
	wnd_ftext(bVdiv,prints("%3d",nVdiv),nTatrb);
	wnd_ftext(bWidth  ,prints("%5.2f",dWidth[0]),nTatrb);
	wnd_ftext(bWidth+1,prints("%5.2f",dWidth[1]),nTatrb);
	wnd_ftext(bWidth+2,prints("%5.2f",dWidth[2]),nTatrb);
	wnd_fmark(bMark,0,(nMark&1)?MARKON:MARKOFF);
	wnd_ftext(bTh,prints("%5.2f",dTh),nTatrb);
	wnd_fmark(bUseTBX,0,(nUseTBX&1)?MARKON:MARKOFF);
	wnd_ftext(bTBXName  ,prints("%-20s",szTBXName),nTatrb);
	wnd_ftext(bTBXGap,prints("%5.2f",dTgap),nTatrb);
	wnd_ftext(bTBXScale,prints("%5.2f",dTscale),nTatrb);
	wnd_ftext(bScale,prints("%5.2f",dScale),nTatrb);
	wnd_ftext(bPivot,prints("%-6s",szPivot[nPivot]),nTatrb);
	wnd_fmark(bBlock,0,(nBlock&1)?MARKON:MARKOFF);
	wnd_ftext(bOfst  ,prints("%7.2f",pOfst.x),nTatrb);
	wnd_ftext(bOfst+1,prints("%7.2f",pOfst.y),nTatrb);
	UpdatePreview();
	UpdBtnState(1);
}
//
void	WndText(int row, int col, char str[])
{
	wnd_loct(row,col);
	put3Dstr(str,nSatrb);
}
//
int	WndEntry(int row, int col, char str[],int fsize,int combo)
{
	int	bID;

	wnd_loct(row,col);
	put3Dstr(str,nSatrb);
	bID = wnd_field(0,0x1f1,fsize);
	if ( combo ) {
		wnd_rloct(0xfe00,0x0600|(fsize&0xff));
		if ( IsWin ) wnd_runit(12);
		if ( identify("cb_empty") ) {   // Supported only after this version
		     wnd_icon(1,0xA77,0x101,OBM_COMBO);
		     wnd_runit(-1);
		     wnd_rloct(0x0200,0x0002);	// locate back
		}
		else {
		     wnd_field(0,IsWin?0x277:0x370,0x101);
		     wnd_runit(IsWin?-1:16);
		     wnd_ftext(bID+1,"",IsWin?0x277:0x270);
		     wnd_rloct(0x0200,0x0201);	// locate back
		}
	}
	return bID;
}
//
int	WndTinyBox(int row, int col)
{
	int	bID;

	wnd_loct(row,col);
	wnd_rloct(0xfe00,0x0400);
	if ( IsWin ) wnd_runit(12);
	bID = wnd_field(0,IsWin?0x277:0x370,0x101);
	wnd_runit(IsWin?-1:16);
	wnd_ftext(bID,"",IsWin?0x277:0x270);
	wnd_rloct(0x0200,0x0401);  // locate back
	return bID;
}
//
int	WndButton(int r,int c, int bsize, char text[])
{
	int	i;
	if ( nSupport ) 	// Having direct support ?
		return wnd_button(r,c,bsize,0x1277,text);
	wnd_loct(r,c);
	i = wnd_field(0,IsWin?0x1277:0x370,bsize);
	wnd_puts(text,0x270);
	return i;
}
//
//	WndGroup() -- Create Grouping window effect
//
void	WndGroup(int r,int c,int width, int height, char text[], int color)
{
	wnd_loct(r,c);
	wnd_rloct(height,0);
	if ( IsWin )
		wnd_field(0,0x277,(height<<8)|width);
	else
		wnd_field(0,((color&0xff)^0x08)|0x200,(height<<8)|width);
	wnd_itemno(1,-1);
	wnd_rloct(-height,2);
	if ( !IsWin )
		wnd_rloct(0xfc00,0);
	put3Dstr(text,color);
	wnd_loct(r&0xff,c);	   // Reset row offset, fix DOS version bug
}
//
//	put3Dstr() -- Drawing 3D text
//
void	put3Dstr(char str[],int atrb)
{
	int	nLen;
	if ( nSupport ) {
		wnd_puts(str,atrb|0x300);
		return;
	}
	nLen=len(str);
	if ( nLen ) {
		wnd_rloct(0x100,IsWin?0x100:0);
		wnd_puts(str,(atrb^0x0f));
		wnd_rloct(0xff00,-nLen);
		wnd_puts(str,(atrb&0xff0f)|0x8000);
	}
}
//
//	WndCheckBox() -- Create window check box
//
int	WndCheckBox(int r,int c,char text[],int atrb)
{
	int	bID;
	if ( nSupport )
		return wnd_rcbox(r,c,text,0);
	wnd_loct(r,c);
	bID = wnd_field(1,0x1f0,0x102);
	wnd_rloct(0,2);
	if ( IsWin )  atrb |= 0x800;
	wnd_puts(text,atrb);
	return bID;
}
//
//	WndRadioBox() -- Create window radio box
//
int	WndRadioBox(int r,int c,char text[],int atrb)
{
	int	bID;
	if ( nSupport )
		return wnd_rcbox(r,c,text,0x8000);
	wnd_loct(r,c);
	bID = wnd_field(1,0x1f0,0x102);
	wnd_rloct(0,2);
	if ( IsWin ) atrb |= 0x800;
	wnd_puts(text,atrb);
	wnd_fmark(bID,1,IsWin?1:MARKON);     // Force to change state
	wnd_fmark(bID,1,IsWin?0:MARKOFF);
	return bID;
}
//
void	SetRadioMark(int bStart, int bEnd, int which)
{
	int	i;
	for(i=bStart;i<=bEnd;i++)
		wnd_fmark(i,1,((which+bStart)==i)?MARKON:MARKOFF);
}
//
void	SetBtnState(int bStart, int bEnd, int state)
{
	int	i;
	for(i=bStart;i<=bEnd;i++)
		wnd_state(i,1,state);
}
//
//	SaveSetup()
//
void	SaveSetup()
{
	int	hdl;
	long	lMagicID;

	if ( !(hdl=fopen(DATAFILE,"w")) )
		return;
	lMagicID = FILEMAGICID;
	fput(hdl,lMagicID,nStd,nPaper,lMagicID);
	fput(hdl,dXsize,dYsize,dMargin);
	if ( nBlock & 1 ) nMark |= 2;
	fput(hdl,nMark,nType,nHori,nVert,nHdiv,nVdiv);
	nMark &= ~2;
	fput(hdl,dWidth,dTh,nPivot);
	fput(hdl,lMagicID,nTBX,MAXTBXCHAR,MAXTBXPATH,nUseTBX,szTBXName);
	fput(hdl,dTscale,dTgap);
	if ( nTBX ) {
		WriteString(hdl,szTBX,nTBX,MAXTBXCHAR);
		WriteString(hdl,szTBXPath,nTBX,MAXTBXPATH);
	}
	fclose(hdl);
}
//
//	WriteString() -- Write string array of specific size to file
//			 with additional terminating code.
//
//	Return: True, if ok, False, if not.
//
BOOL	WriteString(int hdl, char szTable[][],int nCount, int nSize)
{
	if ( nCount <= 0 ) return TRUE;

	long	lMagicID;
	char	szBuf[nCount][nSize];	// Allocate the require size
					// of the data array
	lMagicID = FILEMAGICID;
	setdata(szBuf,szTable); 	// Copy the string array
	return	(fput(hdl,szBuf,lMagicID) != EOF);
}
//
//	WriteInteger() -- Write integer array of specific size to file
//			  with additional terminating code.
//
//	Return: True, if ok, False, if not.
//
BOOL	WriteInteger(int hdl, int nTable[],int nCount)
{
	if ( nCount <= 0 ) return TRUE;

	long	lMagicID;
	int	nBuf[nCount];	// Allocate the required size
					// of the data array
	lMagicID = FILEMAGICID;
	setdata(nBuf,nTable);	      // Copy the string array
	return	(fput(hdl,nBuf,lMagicID) != EOF);
}

BOOL	LoadSetup()
{
	int	hdl;
	long	lMagicID;
	int	nTbxChar, nTbxPath;

	if ( !(hdl=fopen(DATAFILE,"r")) )
		return FALSE;
	switch(FALSE) { // Evaluate cases sequentially in file data order...
	  case (fget(hdl,&lMagicID,&nStd,nPaper)!=EOF):
	  case (lMagicID==FILEMAGICID):
	  case (fget(hdl,&lMagicID)!=EOF):
	  case (lMagicID==FILEMAGICID):
	  case (fget(hdl,&dXsize,&dYsize,dMargin)!=EOF):
	  case (fget(hdl,&nMark,&nType,&nHori,&nVert,&nHdiv,&nVdiv)!=EOF):
	  case (fget(hdl,dWidth,&dTh,&nPivot)!=EOF):
	  case (fget(hdl,&lMagicID,&nTBX,&nTbxChar,&nTbxPath)!=EOF):
	  case (lMagicID==FILEMAGICID):
	  case (fget(hdl,&nUseTBX,szTBXName)!=EOF):
	  case (fget(hdl,&dTscale,&dTgap)!=EOF):
	  case (nTBX>0):
	  case ReadString(hdl,szTBX,nTBX,nTbxChar):
	  case ReadString(hdl,szTBXPath,nTBX,nTbxPath):
		break;
	  default:
		if ( nTBX) {
			nTBXidx = search(szTBXName,szTBX,nTBX);
			if ( nTBXidx < 0 ) nTBXidx = 0;
			szTBXName = szTBX[nTBXidx];
		}
		else {
			nTBXidx = 0;
			szTBXName = "";
		}
		fclose(hdl);
		if ( nMark & 2 ) nBlock |= 1;
		else		 nBlock &= ~1;
		nMark &= ~2;
		return TRUE;	// Table is good and read!
	}
	nTBX = 0;
	fclose(hdl);
	//
	//	Since data has error, we have to check ...
	//
	if ( nStd < 0 ) nStd = 0;
	if ( nStd >= MAXSTD ) nStd = 0;
	memset(nPaper,0);
	nMark &= 1;
	nHori &= 1;
	nVert &= 1;
	if ( nHdiv <= 0 ) nHdiv = 12;
	if ( nVdiv <= 0 ) nVdiv = 10;
	nTBXidx = 0;
	szTBXName = "";
	dTscale = 1.;
	dTgap = 1.;
	nPivot= 1;
	return FALSE;
}
//
//	ReadString() -- Read string array of specific size from file
//			with terminating code checking.
//
//	Return: True, if ok, False, if not.
//
BOOL	ReadString(int hdl, char szTable[][],int nCount, int nSize)
{
	szTable[nCount] = "";           // Add Terminating string
	if ( nCount <= 0 ) return TRUE;

	long	lMagicID;
	char	szBuf[nCount][nSize];	// Allocate the require size
					// of the data array
	fget(hdl,szBuf,&lMagicID);
	if ( lMagicID != FILEMAGICID )
		return FALSE;		// Not Okay!
	setdata(szTable,szBuf); 	// Copy the string array
	szTable[nCount] = "";           // Add Terminating string
	return TRUE;
}
//
//	ReadInteger() -- Read integer array of specific size from file
//			 with terminating code checking.
//
//	Return: True, if ok, False, if not.
//
BOOL	ReadInteger(int hdl, int nTable[],int nCount)
{
	if ( nCount <= 0 ) return TRUE;

	long	lMagicID;
	int	nBuf[nCount];	// Allocate the required size
				// of the data array
	fget(hdl,nBuf,&lMagicID);
	if ( lMagicID != FILEMAGICID )
		return FALSE;		// Not Okay!
	setdata(nTable,nBuf);		// Copy the string array
	return TRUE;
}

void	SaveTbz(char fname[])
{
	int	hdl;
	long	lMagicID;
	char	myfile[80];

	myfile = upper(fname)-".TBX"+".TBZ";

	if ( !(hdl=fopen(myfile,"w")) )
		return;
	lMagicID = FILEMAGICID;
	switch(FALSE) { // Eval case sequentially in file data order...
	    case (fput(hdl,lMagicID,TBZVERSION,lSizeTbx,lDateTbx,nField,nEntry,nTag,nBox,nLine,nFidx,lMagicID)!=EOF):
	    case WriteString(hdl,szField,nField,MAXFDCHAR):
	    case WriteString(hdl,szFText,nField,MAXTEXTCHAR):
	    case WriteString(hdl,szTagText,nField,MAXTEXTCHAR):
	    case WriteInteger(hdl,nFRef,nField):
	    case WriteInteger(hdl,nTagID,nField):
	    case WriteInteger(hdl,nTadj,nField):
	    case WriteInteger(hdl,nWtext,nField):
	    case WriteInteger(hdl,nEntryID,nEntry):
	    case WriteString(hdl,szTag,nTag,MAXTAGCHAR):
	    case WriteInteger(hdl,nTagAtrb,nTag):
	    case WriteString(hdl,szTagPrompt,nTag,MAXTEXTCHAR):
	    case WriteString(hdl,szBox,nBox,MAXBOXCHAR):
	    case WriteInteger(hdl,nAncho,nBox):
	    case WriteInteger(hdl,nAnchoID,nBox):
	    case WriteInteger(hdl,nBH,nBox):
	    case WriteInteger(hdl,nBW,nBox):
	    case WriteInteger(hdl,nBLink,nBox):
	    case WriteInteger(hdl,nLNext,nLine):
	    case WriteInteger(hdl,nLLink,nLine):
	    case WriteInteger(hdl,nLH,nLine):
	    case WriteInteger(hdl,nFNext,nFidx):
	    case WriteInteger(hdl,nFID,nFidx):
	    case WriteInteger(hdl,nFW,nFidx):
	    case (fput(hdl,dMAnsi,dWAnsi,dTAnsi,dGAnsi,dSAnsi,nHAnsi,nVAnsi,nFAnsi,lMagicID)!=EOF):
	    case (fput(hdl,dMCns,dWCns,dTCns,dGCns,dSCns,nHCns,nVCns,nFCns,lMagicID)!=EOF):
	    case (fput(hdl,dMIso,dWIso,dTIso,dGIso,dSIso,nHIso,nVIso,nFIso,lMagicID)!=EOF):
	    case (fput(hdl,dMJis,dWJis,dTJis,dGJis,dSJis,nHJis,nVJis,nFJis,lMagicID)!=EOF):
	    case (fput(hdl,dMDin,dWDin,dTDin,dGDin,dSDin,nHDin,nVDin,nFDin,lMagicID)!=EOF):
		break;
	    default:
		fclose(hdl);
		return;
	}
	fclose(hdl);
	remove(myfile);
	return;
}

int	LoadTbz(char fname[])
{
	int	hdl;
	int	nVersion;
	long	lMagicID, lid;
	long	lsize, ldate;
	char	myfile[80];

	myfile = upper(fname)-".TBX"+".TBZ";

	if ( !(hdl=fopen(myfile,"r")) )
		return -1;
	switch(FALSE) { // Eval case sequentially in file data order...
	  case (fget(hdl,&lMagicID,&nVersion,&lsize,&ldate,&nField,&nEntry,&nTag,&nBox,&nLine,&nFidx,&lid)!=EOF):
	  case (lMagicID==FILEMAGICID):
	  case (lid==FILEMAGICID):
	  case (nVersion==TBZVERSION):
	  case (lsize==lSizeTbx):
	  case (ldate==lDateTbx):
	  case ReadString(hdl,szField,nField,MAXFDCHAR):
	  case ReadString(hdl,szFText,nField,MAXTEXTCHAR):
	  case ReadString(hdl,szTagText,nField,MAXTEXTCHAR):
	  case ReadInteger(hdl,nFRef,nField):
	  case ReadInteger(hdl,nTagID,nField):
	  case ReadInteger(hdl,nTadj,nField):
	  case ReadInteger(hdl,nWtext,nField):
	  case ReadInteger(hdl,nEntryID,nEntry):
	  case ReadString(hdl,szTag,nTag,MAXTAGCHAR):
	  case ReadInteger(hdl,nTagAtrb,nTag):
	  case ReadString(hdl,szTagPrompt,nTag,MAXTEXTCHAR):
	  case ReadString(hdl,szBox,nBox,MAXBOXCHAR):
	  case ReadInteger(hdl,nAncho,nBox):
	  case ReadInteger(hdl,nAnchoID,nBox):
	  case ReadInteger(hdl,nBH,nBox):
	  case ReadInteger(hdl,nBW,nBox):
	  case ReadInteger(hdl,nBLink,nBox):
	  case ReadInteger(hdl,nLNext,nLine):
	  case ReadInteger(hdl,nLLink,nLine):
	  case ReadInteger(hdl,nLH,nLine):
	  case ReadInteger(hdl,nFNext,nFidx):
	  case ReadInteger(hdl,nFID,nFidx):
	  case ReadInteger(hdl,nFW,nFidx):
	  case (fget(hdl,dMAnsi,dWAnsi,dTAnsi,dGAnsi,dSAnsi,nHAnsi,nVAnsi,nFAnsi,&lMagicID)!=EOF):
	  case (lMagicID==FILEMAGICID):
	  case (fget(hdl,dMCns,dWCns,dTCns,dGCns,dSCns,nHCns,nVCns,nFCns,&lMagicID)!=EOF):
	  case (lMagicID==FILEMAGICID):
	  case (fget(hdl,dMIso,dWIso,dTIso,dGIso,dSIso,nHIso,nVIso,nFIso,&lMagicID)!=EOF):
	  case (lMagicID==FILEMAGICID):
	  case (fget(hdl,dMJis,dWJis,dTJis,dGJis,dSJis,nHJis,nVJis,nFJis,&lMagicID)!=EOF):
	  case (lMagicID==FILEMAGICID):
	  case (fget(hdl,dMDin,dWDin,dTDin,dGDin,dSDin,nHDin,nVDin,nFDin,&lMagicID)!=EOF):
	  case (lMagicID==FILEMAGICID):
	      break;
	  default:
	      fclose(hdl);
	      return 0;
	}
	fclose(hdl);
	remove(myfile);
	return -1;
}

int	hdl;
int	lcnt;
char	szBuf[256];
int	nStateTop;
int	nState=1;
int	nIfState[MAXNESTIF];
BOOL	ReloadTBX()
{
	if ( wnd2btn(szText[38]/*"Paper changed and current TBX has conditional clause..."*/,
		szText[39]/*"Reload it to resolve the paper condition?"*/) <= 0 )
		return 0;
	LoadTBX(szTBXPath[nTBXidx]);
	return 1;
}

void	DataInit()
{
	nEntry = nField = nTag = nFidx = nLine = nBox = 0;
	memset(szField,0);
	memset(szTag,0);
	memset(szTagText,0);
	memset(szTagPrompt,0);
	memset(szFText,0);
	memset(nTadj,0);
	memset(nWtext,0);
	memset(szBox,0);
	memset(nAncho,0);
	memset(nFAnsi,0);
	memset(nFCns,0);
	memset(nFIso,0);
	memset(nFJis,0);
	memset(nFDin,0);
	memset(nFRef,0);
	memset(nIfState,0);
	nState = 1;
	nStateTop = 0;
	nEdited = 0;
	nHasCond = 0;
	nHasCal = 0;
}

void	LoadTBX(char fname[])
{
	int	i;
	char	items[2][64];

	printf(szText[37]/*"\nLoading TBX file: '%s' ..."*/,fname);

	lSizeTbx = lDateTbx = 0;
	i=get_dirlist(takepath(fname),takename(fname),items);
	if ( i ) {	// Found!
		memmove(&lSizeTbx,&items[0][14],4);
		memmove(&lDateTbx,&items[0][18],4);
	}
	DataInit();
	if ( LoadTbz(fname) < 0 ) {
		DataInit();
		DoLoadTBX(fname);
		nEntry	= 0;
		for(i=0;i<nField;i++) {
			if ( nTagID[i] < 0 ) continue;
			if ( nFRef[i] & 1 )  nEntryID[nEntry++] = i;
		}
		if ( !nHasCond ) SaveTbz(fname);
	}
}

void	DoLoadTBX(char fname[])
{
	char	szType[80];
	int	hdlsave;
	hdlsave = hdl;
	if ( !(hdl=fopen(fname,"r")) ) {
		hdl = hdlsave;
		printf(szText[36]/*"\nCan not open file: '%s'"*/,fname);
		return 0;
	}
	lcnt = 0;
	while(fgets(szBuf,250,hdl)!=EOF) {
		lcnt++;
		if ( szBuf[0] == ';' ) continue;
		szType = "";
		sscanf(szBuf," %ls %255c",szType,szBuf);
		if ( szType[0]==';' ) continue;
		if ( szType == "" ) continue;
		if ( szType == "#ifpaper" ) {
			if ( szBuf[0] == '"' )
				sscanf(szBuf,"%lS%255c",szType,szBuf);
			else
				sscanf(szBuf,"%ls%255c",szType,szBuf);
			nIfState[nStateTop++] = nState;
			nState *= (szType == szPaperName)?1:0;
			nHasCond = 1;
			continue;
		}
		if ( szType == "#ifnot" ) {
			if ( szBuf[0] == '"' )
				sscanf(szBuf,"%lS%255c",szType,szBuf);
			else
				sscanf(szBuf,"%ls%255c",szType,szBuf);
			nIfState[nStateTop++] = nState;
			nState *= (szType != szPaperName)?1:0;
			nHasCond = 1;
			continue;
		}
		if ( szType == "#else" ) {
			if ( nStateTop ) nState = nIfState[nStateTop-1]*(!nState);
			else  printf("\nTBX -- Illegal #else, at line %d",lcnt);
			continue;
		}
		if ( szType == "#endif" ) {
			if ( nStateTop ) nState = nIfState[--nStateTop];
			else  printf("\nTBX -- Illegal #endif at line %d",lcnt);
			continue;
		}
		if ( !nState ) continue;
		if ( szType == "#include" ) {
			if ( szBuf[0] == '"' )
				sscanf(szBuf,"%lS%255c",szType,szBuf);
			else
				sscanf(szBuf,"%ls%255c",szType,szBuf);
			DoLoadTBX(fsearch(szType));
			continue;
		}
		if ( szBuf[0]!=':' ) {
			printf(szText[32]/*"\nTBX: Syntax error #%d at line %d: '%s'"*/,2,lcnt,szBuf);
			continue;
		}
		szType = upper(szType);
		switch(szType) {
		  case "FIELD": if ( readfield() ) continue;    break;
		  case "BOX":   if ( readbox(0) ) continue;     break;
		  case "TAG":   if ( readtag() ) continue;      break;
		  case "GROUP": if ( readgroup() ) continue;    break;
		  case "MARGIN":if ( readmargin() ) continue;   break;
		  case "BORDER":if ( readborder() ) continue;   break;
		  case "MARKER":if ( readmarker() ) continue;   break;
		  case "GAP":   if ( readgap() ) continue;      break;
		  case "SCALE": if ( readscale() ) continue;    break;
		}
		printf(szText[32]/*"\nTBX: Syntax error #%d at line %d: '%s'"*/,3,lcnt,szBuf);
	}
	fclose(hdl);
	printf(" Ok!");
	hdl = hdlsave;
	return 1;
}
//
//	MARGIN: "paper",left,top,right,bottom
//
double	dm[4];
int	readmargin()
{
	char	szName[80];
	int	i;
	if ( sscanf(szBuf,": %lS %255c",szName,szBuf) < 2 ) return 0;
	if ( szBuf[0] == ',' ) sscanf(szBuf,", %255c",szBuf);
	if ( sscanf(szBuf,"%f , %f , %f , %f",&dm[0],&dm[1],&dm[2],&dm[3]) < 4 ) return 0;
	DoRdMargin(dMAnsi,szAnsi,nFAnsi,MAXANSI,szName);
	DoRdMargin(dMCns ,szCns ,nFCns ,MAXCNS,szName);
	DoRdMargin(dMIso ,szIso ,nFIso ,MAXISO,szName);
	DoRdMargin(dMJis ,szJis ,nFJis ,MAXJIS,szName);
	DoRdMargin(dMDin ,szDin ,nFDin ,MAXDIN,szName);
	return 1;
}

void	DoRdMargin(double dM[][],char szPaper[][],int nFlag[],int nPaper,char szName[])
{
	int	i;
	if ( szName == "*" ) {
		setdata(dM,dm);
		for(i=0;i<nPaper;i++) nFlag[i] |= TBXMARGIN;
		return;
	}
	if ( (i=search(szName,szPaper)) >= 0 ) {
		memmove(&dM[i][0],dm,sizeof(dm));
		nFlag[i] |= TBXMARGIN;
	}
}
//
//	BORDER: "paper",Type,W1,D1,W2
//
double	dw[3];
int	nrdType;
int	readborder()
{
	char	szName[80], szType[80];
	int	i;
	if ( sscanf(szBuf,": %lS %255c",szName,szBuf) < 2 ) return 0;
	if ( szBuf[0] == ',' ) sscanf(szBuf,", %255c",szBuf);
	if ( sscanf(szBuf," %ls , %f , %f , %f",szType,&dw[0],&dw[1],&dw[2]) < 4 ) return 0;
	szType = upper(szType);
	if ( szType == "SINGLE" ) nrdType = 0;
	else if ( szType == "DOUBLE" ) nrdType = 1;
	else return 0;
	DoRdBorder(dWAnsi,szAnsi,nFAnsi,MAXANSI,szName);
	DoRdBorder(dWCns ,szCns ,nFCns ,MAXCNS,szName);
	DoRdBorder(dWIso ,szIso ,nFIso ,MAXISO,szName);
	DoRdBorder(dWJis ,szJis ,nFJis ,MAXJIS,szName);
	DoRdBorder(dWDin ,szDin ,nFDin ,MAXDIN,szName);
	return 1;
}
//
void	DoRdBorder(double dM[][],char szPaper[][],int nFlag[],int nPaper,char szName[])
{
	int	i;
	if ( szName == "*" ) {
		setdata(dM,dw);
		for(i=0;i<nPaper;i++) nFlag[i] |= TBXBORDER;
		if ( nrdType ) for(i=0;i<nPaper;i++) nFlag[i] |= TBXDOUBLE;
		else	       for(i=0;i<nPaper;i++) nFlag[i] &= ~TBXDOUBLE;
		return;
	}
	if ( (i=search(szName,szPaper)) >= 0 ) {
		memmove(&dM[i][0],dw,sizeof(dw));
		nFlag[i] |= TBXMARGIN;
		if ( nrdType ) nFlag[i] |= TBXDOUBLE;
		else	       nFlag[i] &= ~TBXDOUBLE;
	}
}
//
//	MARKER: "paper", Th, hdiv, vdiv
//
double	rdTh;
int	rdHdiv;
int	rdVdiv;
int	readmarker()
{
	char	szName[80];
	int	i;
	if ( sscanf(szBuf,": %lS %255c",szName,szBuf) < 2 ) return 0;
	if ( szBuf[0] == ',' ) sscanf(szBuf,", %255c",szBuf);
	if ( sscanf(szBuf," %f , %d , %d",&rdTh,&rdHdiv,&rdVdiv) < 3 ) return 0;
	DoRdMarker(dTAnsi,nHAnsi,nVAnsi,szAnsi,nFAnsi,MAXANSI,szName);
	DoRdMarker(dTCns ,nHCns ,nVCns ,szCns ,nFCns ,MAXCNS,szName);
	DoRdMarker(dTIso ,nHIso ,nVIso ,szIso ,nFIso ,MAXISO,szName);
	DoRdMarker(dTJis ,nHJis ,nVJis ,szJis ,nFJis ,MAXJIS,szName);
	DoRdMarker(dTDin ,nHDin ,nVDin ,szDin ,nFDin ,MAXDIN,szName);
	return 1;
}
//
void	DoRdMarker(double dT[],int nH[], int nV[], char szPaper[][],int nFlag[],int nPaper,char szName[])
{
	int	i;
	if ( szName == "*" ) {
		setdata(dT,rdTh);
		setdata(nH,rdHdiv);
		setdata(nV,rdVdiv);
		for(i=0;i<nPaper;i++) nFlag[i] |= TBXMARKER;
		return;
	}
	if ( (i=search(szName,szPaper)) >= 0 ) {
		dT[i] = rdTh;
		nH[i] = rdHdiv;
		nV[i] = rdVdiv;
		nFlag[i] |= TBXMARKER;
	}
}
//
//	GAP: "paper", gap
//
double	rdGap;
int	readgap()
{
	char	szName[80];
	int	i;
	if ( sscanf(szBuf,": %lS %255c",szName,szBuf) < 2 ) return 0;
	if ( szBuf[0] == ',' ) sscanf(szBuf,", %255c",szBuf);
	if ( sscanf(szBuf," %f",&rdGap) < 1 ) return 0;
	DoRdGap(dGAnsi,szAnsi,nFAnsi,MAXANSI,szName);
	DoRdGap(dGCns ,szCns ,nFCns ,MAXCNS,szName);
	DoRdGap(dGIso ,szIso ,nFIso ,MAXISO,szName);
	DoRdGap(dGJis ,szJis ,nFJis ,MAXJIS,szName);
	DoRdGap(dGDin ,szDin ,nFDin ,MAXDIN,szName);
	return 1;
}
//
void	DoRdGap(double dT[], char szPaper[][],int nFlag[],int nPaper,char szName[])
{
	int	i;
	if ( szName == "*" ) {
		setdata(dT,rdGap);
		for(i=0;i<nPaper;i++) nFlag[i] |= TBXGAP;
		return;
	}
	if ( (i=search(szName,szPaper)) >= 0 ) {
		dT[i] = rdGap;
		nFlag[i] |= TBXGAP;
	}
}
//
//	SCALE: "paper", scale
//
double	rdScale;
int	readscale()
{
	char	szName[80];
	int	i;
	if ( sscanf(szBuf,": %lS %255c",szName,szBuf) < 2 ) return 0;
	if ( szBuf[0] == ',' ) sscanf(szBuf,", %255c",szBuf);
	if ( sscanf(szBuf," %f",&rdScale) < 1 ) return 0;
	DoRdScale(dSAnsi,szAnsi,nFAnsi,MAXANSI,szName);
	DoRdScale(dSCns ,szCns ,nFCns ,MAXCNS,szName);
	DoRdScale(dSIso ,szIso ,nFIso ,MAXISO,szName);
	DoRdScale(dSJis ,szJis ,nFJis ,MAXJIS,szName);
	DoRdScale(dSDin ,szDin ,nFDin ,MAXDIN,szName);
	return 1;
}
//
void	DoRdScale(double dT[], char szPaper[][],int nFlag[],int nPaper,char szName[])
{
	int	i;
	if ( szName == "*" ) {
		setdata(dT,rdScale);
		for(i=0;i<nPaper;i++) nFlag[i] |= TBXSCALE;
		return;
	}
	if ( (i=search(szName,szPaper)) >= 0 ) {
		dT[i] = rdScale;
		nFlag[i] |= TBXSCALE;
	}
}
//
//	BOX: name,Ancho{/name}, height, width
//
int	readbox(int nest)
{
	char	szName[80];
	int	i, nError, which;
	char	szType[80];
	int	bidx;

	bidx = nBox++;
	nAnchoID[bidx] = -1;
	nBLink[bidx] = -1;
	nAncho[bidx] = -1;
	szBox[bidx] = "";
    if ( !nest ) {
	switch(sscanf(szBuf,": %ls %255c",szName,szBuf)) {
	  case 2:
	    if ( szBuf[0] == ',' ) sscanf(szBuf,", %255c",szBuf);
	    szBox[bidx] = left$(upper(szName),10);
	    if ( szBuf[0] == ',' ) sscanf(szBuf,", %255c",szBuf);
	    sscanf(szBuf,"%d %255c",&nAncho[bidx],szBuf);
	    if ( szBuf[0] == '/' ) {
		    sscanf(szBuf,"/ %ls %255c",szName,szBuf);
		    szName = left$(upper(szName),10);
		    for(i=0;i<nBox;i++) {
			    if ( szName == szBox[i] ) {
				    nAnchoID[bidx] = i;
				    break;
			    }
		    }
		    if ( i == nBox )
			    printf(szText[34]/*"\nReference to undefine Box name: '%s' at line %d"*/,szName,lcnt);
	    }
	    if ( szBuf[0] == ',' ) sscanf(szBuf,", %255c",szBuf);
	    sscanf(szBuf,"%d %255c",&i,szBuf);
	    nAncho[bidx] &= 0x03;
	    nAncho[bidx] |= (i&0x03)<<4;
	    if ( szBuf[0] == ',' ) sscanf(szBuf,", %255c",szBuf);
	    sscanf(szBuf,"%d , %d",&nBH[bidx],&nBW[bidx]);
	    break;
	  case 1:
	    szBox[bidx] = left$(upper(szName),10);
	    break;
	  default:
	    return 0;
	}
	nError = 0;
	while(fgets(szBuf,250,hdl)!=EOF) {
		lcnt++;
		sscanf(szBuf," %255c",szBuf);
		if ( szBuf == "" ) continue;
		if ( szBuf[0] == ';' ) continue;
		if ( szBuf[0] == '{' ) break;
		if ( nError == 0 )
			printf(szText[33]/*"\nSyntax error %d at line %d, missing '%s'"*/,8,lcnt,"{");
		nError++;
	}
    }
	while(fgets(szBuf,250,hdl)!=EOF) {
		lcnt++;
		sscanf(szBuf," %255c",szBuf);
		if ( szBuf == "" ) continue;
		if ( szBuf[0] == ';' ) continue;
		if ( szBuf[0] == '}' ) {
			szBuf -= "}";
			break;
		}
		sscanf(szBuf," %ls%255c",szType,szBuf);
		if ( szBuf[0]!=':' ) {
			printf(szText[32]/*"\nTBX: Syntax error #%d at line %d: '%s'"*/,5,lcnt,szBuf);
			continue;
		}
		if ( upper(szType) != "ROW" && upper(szType) != "LINE" ) {
			printf(szText[32]/*"\nTBX: Syntax error #%d at line %d: '%s'"*/,6,lcnt,szBuf);
			continue;
		}
		which = readrow();
		if ( which >= 0 ) {	// Make the list
			nLNext[which] = nBLink[bidx];
			nBLink[bidx] = which;
		}
	}
	return bidx+1;
}
//
//	ROW:
//
int	readrow()
{
	char	szName[80], szAdj[80], szTmp[80];
	int	i, idx, jdx, hidx;
	int	nDirect;
	int	nWhich, nFwidth;
	nWhich = nLine++;	// For recursive
	if ( sscanf(szBuf,": %d %255c",&nLH[nWhich],szBuf) < 2 ) {
		printf(szText[32]/*"\nTBX: Syntax error #%d at line %d: '%s'"*/,7,lcnt,szBuf);
		nLine--;
		return -1;
	}
	if ( szBuf[0] == ',' ) sscanf(szBuf,", %255c",szBuf);
	nLLink[nWhich] = -1;
	while(szBuf!="") {
		nDirect = 0;
		nFwidth = 0;
		szAdj = "";
		if ( szBuf[0] == '"' ) {        // Un-named field
			if ( sscanf(szBuf,"%lS %255c",szName,szBuf) < 2 ) szBuf = "";
			nDirect = 1;
			if ( szBuf[0] == '/' ) {
				if ( sscanf(szBuf,"/ %ls%255c",szTmp,szBuf) < 2 ) szBuf = "";
				sscanf(szTmp,"%d%40c",&nFwidth,szAdj);
			}
		}
		else if ( szBuf[0] == '@' ) {   // Vector inclusion
			if ( sscanf(szBuf,"@ %ls%255c",szName,szBuf) < 2 ) szBuf = "";
			if ( i=index(szName,"/") ) {
				sscanf(&szName[i],"%d%40c",&nFwidth,szAdj);
				szName = left$(szName,i-1);
			}
			nDirect = 2;
		}
		else if ( szBuf[0] == '{' ) {   // Nested box
			if ( sscanf(szBuf,"{ %ls%255c",szName,szBuf) < 2 ) szBuf = "";
			if ( szName[0]=='/' )
				sscanf(szName,"/ %d%40c",&nFwidth,szAdj);
			nDirect = -1;
		}
		else {
			if ( sscanf(szBuf," %ls%255c",szName,szBuf) < 2 ) szBuf = "";
			if ( i=index(szName,"/") ) {
				sscanf(&szName[i],"%d%40c",&nFwidth,szAdj);
				szName = left$(szName,i-1);
			}
		}
		if ( szBuf[0] == ',' ) sscanf(szBuf,", %255c",szBuf);
		switch(nDirect) {
		  case 2:
		  case 1:
			szField[nField] = (nDirect==1)?" ":"@";  // Un-named
			szFText[nField] = szName;
			szTagText[nField] = "";
			nTagID[nField] = -1;	// No tags
			nTadj[nField] = 0;
			switch(left$(szAdj,1)) {
			  case "L": case "l": nTadj[nField] |= 0;      break;
			  case "R": case "r": nTadj[nField] |= 0x10;   break;
			  case "C": case "c": nTadj[nField] |= 0x20;   break;
			  case "E": case "e": nTadj[nField] |= 0x30;   break;
			  case "F": case "f": nTadj[nField] |= 0x40;   break;
			}
			szAdj -= left$(szAdj,1);
			if ( left$(szAdj,2) == "90" ) nTadj[nField] |= 0x80;     // Rotated
			i = nField++;
			nFRef[i] = 1;	// Field referenced
			break;
		  case 0:
			i = search(left$(upper(szName),10),szField,nField);
			if ( i < 0 ) {
				printf(szText[35]/*"\nUndefined Field '%s' at line %d"*/,szName,lcnt);
				continue;
			}
			nFRef[i] = 1;	// Field referenced
			break;
		  case -1:	// Ah, is a nested box!
			i = readbox(1)-1;
			i |= 0x8000;
			if ( szBuf[0] == ',' ) sscanf(szBuf,", %255c",szBuf);
			break;
		}
		nFW[nFidx] = nFwidth;
		nFID[nFidx] = i;
		nFNext[nFidx] = nLLink[nWhich];
		nLLink[nWhich] = nFidx;
		nFidx++;
	}
	//
	//	Reverse the single link list order
	//
	hidx = -1;
	for(idx=nLLink[nWhich];idx!=-1;idx=jdx) {
		jdx = nFNext[idx];
		nFNext[idx] = hidx;
		hidx = idx;
	}
	nLLink[nWhich] = hidx;
	return nWhich;
}
//
//	GROUP:
//
int	readgroup()
{
	// skip group
	while(fgets(szBuf,250,hdl)!=EOF) {
		lcnt++;
		sscanf(szBuf," %255c",szBuf);
		if ( szBuf == "" ) continue;
		if ( szBuf[0] == ';' ) continue;
		if ( szBuf[0] == '{' ) break;
		if ( nError == 0 )
			printf(szText[33]/*"\nSyntax error %d at line %d, missing '%s'"*/,9,lcnt,"{");
		nError++;
	}

	while(fgets(szBuf,250,hdl)!=EOF) {
		lcnt++;
		sscanf(szBuf," %255c",szBuf);
		if ( szBuf == "" ) continue;
		if ( szBuf[0] == ';' ) continue;
		if ( szBuf[0] == '}' ) break;
		if ( szBuf[0] == '{' ) break;
	}
	if ( szBuf[0] != '}' )
		printf(szText[33]/*"\nSyntax error %d at line %d, missing '%s'"*/,10,lcnt,"}");
	return 1;
}
//
//	TAG: Name,{D,V},"Prompting string"
//
int	readtag()
{
	char	szName[80];
	int	idx;
	if ( sscanf(szBuf,": %ls %255c",szName,szBuf) < 2 ) return 0;
	if ( szBuf[0] == ',' ) sscanf(szBuf,", %255c",szBuf);
	szName = left$(upper(szName),12);
	idx = nTag;
	if ( nTag > 0 ) {	// Redefine Tags!
		idx = search(szName,szTag,nTag);
		if ( idx < 0 ) idx = nTag;
	}
	szTag[idx] = szName;
	nTagAtrb[idx] = 0;
	if ( szBuf[0]!='"' ) {
		if ( sscanf(szBuf,"%ls %255c",szName,szBuf) < 2 ) return 0;
		if ( szBuf[0] == ',' ) sscanf(szBuf,", %255c",szBuf);
		if ( upper(szName) == "D" ) nTagAtrb[idx] |= TAGDISP;
		if ( upper(szName) == "V" ) nTagAtrb[idx] |= TAGVAR;
	}
	if ( szBuf[0]!='"' ) {
		if ( sscanf(szBuf,"%ls %255c",szName,szBuf) < 2 ) return 0;
		if ( szBuf[0] == ',' ) sscanf(szBuf,", %255c",szBuf);
		if ( upper(szName) == "D" ) nTagAtrb[idx] |= TAGDISP;
		if ( upper(szName) == "V" ) nTagAtrb[idx] |= TAGVAR;
	}
	if ( szBuf[0]!='"' ) return 0;
	sscanf(szBuf,"%lS %255c",szName,szBuf);
	szTagPrompt[idx] = szName;
	if ( idx == nTag )
		nTag++;
	return 1;
}
//
//	FIELD:				(Empty field)
//	FIELD: "Text",Tadj              (Static text)
//	FIELD: Name,Tag,Tadj,"Default"{,Wt,"Text",Tadj}
//
int	readfield()
{
	char	szName[80];
	int	idx;
	int	hastag=0;

	if ( sscanf(szBuf,": %ls %255c",szName,szBuf) < 2 ) return 0;
	if ( szBuf[0] == ',' ) sscanf(szBuf,", %255c",szBuf);
	szField[nField] = left$(upper(szName),10);
	szTagText[nField] = szFText[nField] = "";
	nTadj[nField] = 0;
	nTagID[nField] = -1;

	if ( szBuf[0] != '"' ) {
		hastag = 1;
		sscanf(szBuf," %ls %255c",szName,szBuf);
		if ( szBuf[0] == ',' ) sscanf(szBuf,", %255c",szBuf);
		szName = left$(upper(szName),12);
		if ( nTag > 0 ) idx = search(szName,szTag,nTag);
		else		idx = -1;
		if ( idx >= 0 ) nTagID[nField] = idx;
		else {		// Add new TAG
			nTagID[nField] = nTag;
			szTag[nTag] = szName;
			szTagPrompt[nTag] = szName;
			nTagAtrb[nTag] = TAGDISP|TAGVAR;
			nTag++;
		}
		sscanf(szBuf," %ls %255c",szName,szBuf);
		switch(left$(szName,1)) {
		  case "L": case "l": nTadj[nField] |= 0;      break;
		  case "R": case "r": nTadj[nField] |= 0x1;    break;
		  case "C": case "c": nTadj[nField] |= 0x2;    break;
		  case "E": case "e": nTadj[nField] |= 0x3;    break;
		  case "F": case "f": nTadj[nField] |= 0x4;    break;
		}
		szName -= left$(szName,1);
		if ( left$(szName,2) == "90" ) nTadj[nField] |= 0x8;     // Rotated
		if ( szBuf[0] == ',' ) sscanf(szBuf,", %255c",szBuf);
		if ( szBuf[0] != '"' ) return 0;
		sscanf(szBuf,"%lS %255c",szName,szBuf);
		szTagText[nField] = szName;
		if ( szBuf[0] == ',' ) sscanf(szBuf,", %255c",szBuf);
		if ( szBuf == "" ) {
			nField++;
			return 1;
		}
		sscanf(szBuf,"%d, %255c",&nWtext[nField],szBuf);
	}
	if ( szBuf[0] == '"' ) {
		sscanf(szBuf,"%lS %255c",szName,szBuf);
		szFText[nField] = szName;
		if ( szBuf[0] == ',' ) sscanf(szBuf,", %255c",szBuf);
		switch(left$(szBuf,1)) {
		  case "L": case "l": nTadj[nField] |= 0;      break;
		  case "R": case "r": nTadj[nField] |= 0x10;   break;
		  case "C": case "c": nTadj[nField] |= 0x20;   break;
		  case "E": case "e": nTadj[nField] |= 0x30;   break;
		  case "F": case "f": nTadj[nField] |= 0x40;   break;
		}
		szBuf -= left$(szBuf,1);
		if ( left$(szBuf,2) == "90" ) nTadj[nField] |= 0x80;     // Rotated
		nField++;
		return 1;
	}
	else if ( hastag ) return 0;
	nField++;
	return 1;
}

POINT	pMainMin, pMainMax;
POINT	pBoxMin[MAXBOX],pBoxMax[MAXBOX];

void	DrawTBX(int plot)
{
	int	i;
	double	w;

	p1 = p(dMargin[0],dMargin[3]);
	p2 = p(GetXsize(),GetYsize())-p(dMargin[2],dMargin[1]);
	w = dWidth[0]/2;
	if ( nType && dWidth[1]>0 ) {
		p1 += p(dWidth[1],dWidth[1]);
		p2 -= p(dWidth[1],dWidth[1]);
		w = dWidth[2]/2;
	}
	p1 += p(w,w);
	p2 -= p(w,w);
	pMainMin = p1;
	pMainMax = p2;
	if ( !plot ) {
		pMainMin *= dScale;
		pMainMax *= dScale;
		pMainMin += pOfst;
		pMainMax += pOfst;
	}
	for(i=0;i<nBox;i++) DrawBox(i,plot);
	nHasCal = 1;
}

void	DrawBox(int n,int plot)
{
	int	cmdecho=@cmdecho;
	double	dHeight, dWidth, dhscale, ds, ts;
	int	idx;
	POINT	pBase, pMin, pMax, pDelta, pTop;

	if ( nAncho[n] == -1 ) {
		if ( szBox[n] == "" ) return;  // This is a nested box
	}

	@cmdecho = 0;

	if ( nHasCal ) dHeight = dBH[n];
	else {
		dHeight = 0;
		for(idx=nBLink[n];idx!=-1;idx=nLNext[idx])
			dHeight += abs(nLH[idx]);
		dBH[n] = dHeight;
	}
	ts = dTscale;
	dhscale = 1;
	if ( nAncho[n] != -1 ) {
		if ( nBH[n] ) dhscale = abs(nBH[n])/dHeight;

		dWidth = abs(nBW[n])*dTscale;
		dHeight *= dTscale*dhscale;

		if ( nAnchoID[n] < 0 ) {
			pMin = pMainMin;
			pMax = pMainMax;
		}
		else {
			pMin = pBoxMin[nAnchoID[n]];
			pMax = pBoxMax[nAnchoID[n]];
		}
		switch(nAncho[n]&0x03) {
		  case 0:	pBase = pMin; break;
		  case 1:	pBase = p(pMax.x,pMin.y); break;
		  case 2:	pBase = pMax; break;
		  case 3:	pBase = p(pMin.x,pMax.y); break;
		}
		switch(nAncho[n]&0x30) {
		  case 0x00:	pDelta = p(dWidth,dHeight); break;
		  case 0x10:	pDelta = p(-dWidth,dHeight); break;
		  case 0x20:	pDelta = p(-dWidth,-dHeight); break;
		  case 0x30:	pDelta = p(dWidth,-dHeight); break;
		}
		pTop = pBase + pDelta;
		if ( plot )
			plotent(L(pBase,p(pTop.x,pBase.y)),
				L(p(pTop.x,pBase.y),pTop),
				L(pTop,p(pBase.x,pTop.y)),
				L(p(pBase.x,pTop.y),pBase));
		else
			command("BOX \@pBase \@pTop^M");
		pMin = Min(pBase.x,pTop.x),Min(pBase.y,pTop.y);
		pMax = Max(pBase.x,pTop.x),Max(pBase.y,pTop.y);
		ds = dTscale*dhscale;
	}
	else {	    // Special box, the total frame
		pMin = pMainMin;
		pMax = pMainMax;
		dhscale = (pMax-pMin).y/dHeight;
		dWidth = (pMax-pMin).x;
		dHeight = (pMax-pMin).y;
		ds = dhscale;
		dTscale = 1.;
	}
	pBoxMin[n] = pMin;
	pBoxMax[n] = pMax;
	pBase = pMin;
	for(idx=nBLink[n];idx!=-1;idx=nLNext[idx]) {
		pTop = pBase + p(0,abs(nLH[idx])*ds);
		if ( plot ) {
			if ( nLNext[idx] != -1 ) plotent(L(pTop,pTop+p(dWidth,0)));
			PlotLine(idx,pBase,pTop,dWidth);
		}
		else {
			if ( nLNext[idx] != -1 ) newent(L(pTop,pTop+p(dWidth,0)));
			DrawLine(idx,pBase,pTop,dWidth);
		}
		pBase = pTop;
	}
	dTscale = ts;
	@cmdecho = cmdecho;
}

void	DrawNestBox(int n,POINT pMin, POINT pMax, int plot)
{
	int	cmdecho=@cmdecho;
	double	dHeight, dWidth, ds;
	int	idx;
	POINT	pBase, pDelta, pTop;

	@cmdecho = 0;

	if ( nHasCal ) dHeight = dBH[n];
	else {
		dHeight = 0;
		for(idx=nBLink[n];idx!=-1;idx=nLNext[idx])
			dHeight += abs(nLH[idx]);
		dBH[n] = dHeight;
	}

	dWidth = abs((pMax-pMin).x);
	ds = abs((pMax-pMin).y)/dHeight;
	pBase = pMin;
	pTop = pMax;

	pBoxMin[n] = pMin;
	pBoxMax[n] = pMax;
	pBase = pMin;
	for(idx=nBLink[n];idx!=-1;idx=nLNext[idx]) {
		pTop = pBase + p(0,abs(nLH[idx])*ds);
		if ( plot ) {
			if ( nLNext[idx] != -1 ) plotent(L(pTop,pTop+p(dWidth,0)));
			PlotLine(idx,pBase,pTop,dWidth);
		}
		else {
			if ( nLNext[idx] != -1 ) newent(L(pTop,pTop+p(dWidth,0)));
			DrawLine(idx,pBase,pTop,dWidth);
		}
		pBase = pTop;
	}
	@cmdecho = cmdecho;
}
//
void	DoLineCal(int n,POINT pBase, POINT pTop, double dWidth)
{
	int	idx;
	double	dw, ratio, dh, dwLeft;

	dw = 0;
	for(idx=nLLink[n];idx!=-1;idx=nFNext[idx]) {
		if ( nFW[idx] > 0 )	 dw += nFW[idx]*dTscale;
		else if ( nFW[idx] < 0 ) dw += dWidth*abs(nFW[idx])/100;
		else if ( dw < dWidth )  dw = dWidth;
		else			 dw *= 1.1;
	}
	ratio = dWidth/dw;
	dwLeft = dWidth;
	for(idx=nLLink[n];idx!=-1;idx=nFNext[idx]) {
		dw = nFW[idx];
		if ( dw < 0 ) dw *= dWidth/100;
		else	      dw *= dTscale;
		dw *= ratio;
		if ( dw == 0. ) dw = dwLeft;
		dw = abs(dw);
		dFW[idx] = dw;
		dwLeft -= dw;
	}
}
//
void	DrawLine(int n,POINT pBase, POINT pTop, double dWidth)
{
	int	idx;
	double	dh;
	POINT	pLast, pNext, pDelta;

	if ( !nHasCal ) DoLineCal(n, pBase, pTop, dWidth);

	pDelta = pTop-pBase;
	pLast = pBase;
	dh = (pTop-pBase).y;

	for(idx=nLLink[n];idx!=-1;idx=nFNext[idx]) {
		pNext = pLast + p(dFW[idx],0);
		if ( nFNext[idx] != -1 ) newent(L(pNext,pNext+pDelta));
		DrawField(idx,pLast,pNext,dh);
		pLast = pNext;
	}
}
//
//	Optimize for faster preview generation
//
void	PlotLine(int n,POINT pBase, POINT pTop, double dWidth)
{
	int	idx;
	double	dh;
	POINT	pLast, pNext, pDelta;

	if ( !nHasCal ) DoLineCal(n, pBase, pTop, dWidth);

	pDelta = pTop-pBase;
	pLast = pBase;
	dh = (pTop-pBase).y;
	for(idx=nLLink[n];idx!=-1;idx=nFNext[idx]) {
		pNext = pLast + p(dFW[idx],0);
		if ( nFNext[idx] != -1 ) plotent(L(pNext,pNext+pDelta));
	//
	//	PlotField(idx,pLast,pNext,dh);
	//
		i0 = nFID[idx];
		if ( i0 & 0x8000 ) {  // Nested box
			DrawNestBox(i0&0x7fff,pLast,pNext+p(0,dh),1);
		}
		else if ( nWtext[i0] > 0 ) {
			p1 = pLast+(pNext-pLast)*nWtext[i0]/100.;
			plotent(L(p1,p1+p(0,dh)));
		}
		pLast = pNext;
	}
}
//
//	Faster routine for faster preview
//
void	PlotField(int n, POINT pBase, POINT pTail, double dh)
{
	int	nIdx;
	POINT	pMid;
	nIdx = nFID[n];
	if ( nIdx & 0x8000 ) {	// Nested box
		DrawNestBox(nIdx&0x7fff,pBase,pTail+p(0,dh),1);
		return;
	}
	if ( nWtext[nIdx]<=0 ) return;
	pMid = pBase+(pTail-pBase)*nWtext[nIdx]/100.;
	plotent(L(pMid,pMid+p(0,dh)));
}

void	DrawField(int n, POINT pBase, POINT pTail, double dh)
{
	int	nIdx, nTidx, nAtrb;
	POINT	pMid, pText;
	double	th, dth;
	ENTDATA data;
	char	str[80];
	double	tdist, gap;
	double	csp, a,b,c, wf;

	nIdx = nFID[n];
	if ( nIdx & 0x8000 ) {	// Nested box
		DrawNestBox(nIdx&0x7fff,pBase,pTail+p(0,dh),0);
		return;
	}

	nTidx = nTagID[nIdx];

	gap = dTgap;
	if ( gap < 0 ) gap = abs(dh*gap/100.);
	if ( gap == 0 ) gap = dh*0.10;
	if ( gap > dh*0.25 ) gap = dh*0.25;

	th = dh - 2*gap;
	if ( nWtext[nIdx]>0 ) {   // Must have text title
		pMid = pBase+(pTail-pBase)*nWtext[nIdx]/100.;
		newent(L(pMid,pMid+p(0,dh)));
		NewText(pBase,pMid,szFText[nIdx],th,nTadj[nIdx]>>4,gap);
		pBase = pMid;
	}
	else if ( nWtext[nIdx] < 0 ) {
		th -= gap;
		dth = th*abs(nWtext[nIdx])/100.;
		th  -= dth;
		pText = pBase+p(0,gap+th);
		pMid = pTail+p(0,gap+th);
		NewText(pText,pMid,szFText[nIdx],dth,nTadj[nIdx]>>4,gap);
	}
	else if ( nTidx < 0 ) { // Static Text
		if ( szField[nIdx] == "@" )     // Vector inclusion
			DrawVector(pBase,pTail,szFText[nIdx],dh,nTadj[nIdx]>>4,gap);
		else
			NewText(pBase,pTail,szFText[nIdx],th,nTadj[nIdx]>>4,gap);
		return;
	}
//
//	Reset default text style condition here
//
	@TXTWIDTHF = 0;
	@TXTHEIGHT = th;
	@TXTOBANGLE = 0;
	@TXTCSPACE = 0;
	@TXTROTCCW = 0;

	p1 = pBase + p(gap,gap);
	p2 = pTail + p(-gap,gap);
	p3 = (p1+p2)/2;
	nAtrb = nTagAtrb[nTidx]|TAGDISP;
	if ( nBlock & 1 ) {	// Need Attdef for block definition
	    str = "&&";         // Attdef Text mark
	    if ( !(nAtrb & TAGDISP) ) str += "!";       // Invisible ?
	    if ( !(nAtrb & TAGVAR) )  str += "#";       // Constant ?
	    str += szTag[nTidx]+":"+szTagText[nIdx];
	    switch(nTadj[nIdx]&0x0f) {
	      case 1:  command(prints("TEXT J R^Mp2 \@th 0 @!\@str^M^M")); return;
	      case 2:  command(prints("TEXT J C^Mp3 \@th 0 @!\@str^M^M")); return;
	      case 3:  command(prints("TEXT J E^Mp1 p2 \@th @!\@str^M^M")); break;
	      case 4:  command(prints("TEXT J F^Mp1 p2 \@th @!\@str^M^M")); break;
	      default: command(prints("TEXT J ^Mp1 \@th 0 @!\@str^M^M")); return;
	    }
	//
	//	Well, since the tag conversion does not automatically adjust
	//	the text for fitting requirement, we have to do it all by
	//	ourself. This is a bug of TwinCAD before V3.1.054a.
	//
	    eTdef[nTdef] = ent_last();
	    dTlen[nTdef] = v(p1,p2);
	    nTdef++;
	    return;
	}
	switch(nTadj[nIdx]&0x0f) {
	  case 1:   e1=add_tag(0,szTag[nTidx],szTagText[nIdx],nAtrb,p2,0,2); return;
	  case 2:   e1=add_tag(0,szTag[nTidx],szTagText[nIdx],nAtrb,p3,0,1); return;
	  case 3:
	  case 4:   e1=add_tag(0,szTag[nTidx],szTagText[nIdx],nAtrb,p1,0,0); break;
	  default:  e1=add_tag(0,szTag[nTidx],szTagText[nIdx],nAtrb,p1,0,0); return;
	}
//
//	Well, since the add_tag() does not support the fitting alignment of a
//	visible tag, we will have to do it ourself.
//
	data = ent_read(e1);
//
//	We can not use the data.tag.tlen as the true text span here ...
//	However, since this is a newly created tag, it follows current
//	text style setup. We simply use text_span() to obtain its true length.
//
	a = text_span(szTagText[nIdx]);
	tdist = v(p1,p2);
	if ( (nTadj[nIdx]&0x0f) == 3 ) {	// Even fit
		data.tag.tadj = 0x300;	// Set Even Fit
		csp = @TXTCSPACE;
		@TXTCSPACE = 0;
		a = text_span(szTagText[nIdx]);
		@TXTCSPACE = csp;
		if ( tdist > a ) {	// Have room!
			@TXTCSPACE = 1;
			b = text_span(szTagText[nIdx]);
			@TXTCSPACE = csp;
			c = b-a-1;
			if ( c > 0 ) data.tag.csp = (tdist-a)/c;
			else	     data.tag.csp = 0;
			ent_write(e1,data);
			return;
		}
		// fall down for fitting
	}
	else {	    // Simple Fitting
		data.tag.tadj = 0x200;
	}
	wf = tdist/a;
	if ( data.tag.csp!=0. ) {
		csp = @TXTCSPACE;
		@TXTCSPACE = 0;
		b = text_span(szTagText[nIdx]);
		@TXTCSPACE = csp;
		c = a - b;
		if ( tdist < c ) {
			data.tag.csp = 0;
			wf = tdist/a;
		}
		else {
			wf = (tdist-c)/b;
		}
	}
	a = data.tag.obangle % (2*pi);
	if ( abs(a) >= pi ) {
	    if ( a > 0 ) a = 2*pi - a;
	    else	 a = -2*pi - a;
	}
	if ( abs(a) >= pi/2 )
	    wf = 1/(data.tag.height*wf);
	if ( data.tag.width == 0. ) data.tag.width = 1;
	data.tag.width *= wf;
	ent_write(e1,data);
}

void	DrawVector(POINT pStart, POINT pEnd, char str[], double dh, int adj, double gap)
{
	int	cmdecho=@cmdecho;
	char	fname[80];
	p1 = pStart;		// Lower-Left corner
	p2 = pEnd+p(0,dh);	// Upper right corner
	i0 = adj;		// Justification code
	v0 = gap;		// Text Gap
	v1 = dScale;		// Total scale factor
	s0 = "VEC";             // ID code
	s1 = szPaperName;	// Paper Name
	cmdecho = 1;
	if ( !index(str,".") ) fname = fsearch(str+".vec");
	else	fname = fsearch(str);
//
	run(fname,TPA_KEY);
//
	@cmdecho = cmdecho;
}

void	NewText(POINT pStart, POINT pEnd, char str[],double th,int adj, double gap)
{
	int	cmdecho=@cmdecho;
	int angle;
	double	fw;
	if ( str == "" ) return;

	@cmdecho = 0;
	fw = v(pStart,pEnd)-2*gap;
	if ( fw > 2*th ) adj &= ~0x08;	// Override vertical
	if ( th > 2*fw ) adj |= 0x08;	// override horizontal
	if ( adj & 0x08 ) {	// 90 degree, vertical text
		p1 = pStart + p(gap,th+gap);
		p2 = pStart + p(gap,gap);
		@TXTROTCCW = 1;
		angle = 270;	// Vertical downword.
		th = fw;
	}
	else {
		p1 = pStart + p(gap,gap);
		p2 = pEnd + p(-gap,gap);
		@TXTROTCCW = 0;
		angle = 0;
	}
	p3 = (p1+p2)/2;
	switch(adj&0x07) {
	  case 1:  command(prints("TEXT J R^Mp2 \@th %d @!\@str^M^M",angle)); break;
	  case 2:  command(prints("TEXT J C^Mp3 \@th %d @!\@str^M^M",angle)); break;
	  case 3:  command(prints("TEXT J E^Mp1 p2 \@th @!\@str^M^M")); break;
	  case 4:  command(prints("TEXT J F^Mp1 p2 \@th @!\@str^M^M")); break;
	  default: command(prints("TEXT J ^Mp1 \@th %d @!\@str^M^M",angle)); break;
	}
	@TXTROTCCW = 0;
	@cmdecho = cmdecho;
}
//
int	FindAllTBX()
{
	nTBX = 0;
	SearchAllTBX();
	if ( nTBX ) {
		SortTable();
		nTBXidx = search(szTBXName,szTBX,nTBX);
		if ( nTBXidx < 0 ) {
			nTBXidx = 0;
			szTBXName = szTBX[nTBXidx];
		}
	}
	return nTBX;
}
//
void	SortTable()
{
	int	nIdx[nTBX];

	if ( nTBX > 1 ) {
		sort(szTBX,nTBX,0,nIdx);
		setdata(szTBXPath,szTBXPath,nIdx);
	}
	// Add Terminating string

	szTBX[nTBX] = "";
	szTBXPath[nTBX] = "";
}

#define MAXDIR	10
void	SearchAllTBX()
{
	char	dirlist[MAXDIR][128];
	int	nDir;
	int	i;

	nDir = 0;
	dirlist[nDir++] = get_syspath(0);	// TwinCAD directory
	dirlist[nDir++] = get_syspath(0)+"\\SUPPORT";
	dirlist[nDir++] = get_syspath(0)+"\\COMMANDS";

	sort(dirlist,nDir);	// Sort it to remove redundant paths
	for(i=1;i<nDir;i++) {
		if ( dirlist[i-1] == dirlist[i] )
			dirlist[i-1] = "";      // Remove it
	}

	for(i=0;i<nDir;i++) {	// Zap out empty paths
		if ( dirlist[i] == "" ) {
			dirlist[i] = dirlist[--nDir];
			i--;
		}
	}

	userbrk(0);
	printf(szText[30]/*"\nSearching for all TBX files..."*/);
	for(i=0;i<nDir;i++)
		if ( dirlist[i]!="" ) SearchTBX(dirlist[i]);
	printf(szText[31]/*" Ok, %d found."*/,nTBX);
	userbrk(1);
}
//
//	SearchTBX() -- Search for specific TBX file from given path
//
void	SearchTBX(char szPath[])
{
	char	szNames[MAXTBX][14];
	char	szFilename[128], szBuf[256], szTmp[80];
	int	i, j;
	int	nCount;
	int	nOsLang=os_language();
	double	ver;
	int	hdl;

	nCount = get_dirlist(szPath,"*.TBX",szNames,7);

	for(i=0;i<nCount;i++) {
		szFilename = szPath + "\\" + szNames[i];
		if ( !(hdl=fopen(szFilename,"r"))) continue;
		fgets(szBuf,250,hdl);
		if ( szBuf[0]!=';' || szBuf[1] !='*' ) {
			szTBX[nTBX] = takename(szFilename)-".TBX";
			szTBXPath[nTBX] = szFilename;
			fclose(hdl);
			nTBX++;
			continue;
		}
		sscanf(szBuf,";* %255c",szBuf);
		szTBX[nTBX] = left$(szBuf,MAXTBXCHAR-1);
		szTBXPath[nTBX] = szFilename;
		fgets(szBuf,250,hdl);
		if ( szBuf[0]==';' && szBuf[1] =='*' ) {
			sscanf(szBuf,";* %ls%255c",szTmp,szBuf);
			j = eval(szTmp);
			if ( j && (j!=nOsLang) ) {
				printf("\nTBX -- Can not support '%s'",szFilename);
				fclose(hdl);
				continue;	// Skip, need language support
			}
		}
		fgets(szBuf,250,hdl);
		fclose(hdl);
		if ( szBuf[0]==';' && szBuf[1] =='*' ) {
			ver = 0;
			sscanf(szBuf,";* V%f",&ver);
			if ( ver > MYVERSION ) { // Not supported
				printf("\nTBX V%3.1f -- Can not support '%s'",MYVERSION,szFilename);
				continue;
			}
		}
		nTBX++;
		continue;
	}
}
//
//	FieldEntry -- Let the operator to enter field data
//
int	bStart;
int	bOkEntry, bNext, bLast;
#define MAXITEM 6
FieldEntry()
{
	int	i, nBtn;
	int	nStart;

	if ( nEntry == 0 ) return;	// Nothing to do

	nStart = 0;
	OpenEntryDlg(nStart);
	UpdEntryDlg(nStart);
	for(;;) {
		nBtn = wnd_gbtn(0);
		switch(nBtn) {
		  case	0:	break;
		  case bOkEntry:
			break;
		  case bNext:
			if ( (nStart+MAXITEM)>=nEntry ) {
				beep();
				continue;
			}
			nStart += MAXITEM;
			wndclose();
			OpenEntryDlg(nStart);
			UpdEntryDlg(nStart);
			continue;
		  case bLast:
			if ( nStart == 0 ) {
				beep();
				continue;
			}
			nStart -= MAXITEM;
			wndclose();
			OpenEntryDlg(nStart);
			UpdEntryDlg(nStart);
			continue;
		  default:
			if ( nBtn >= bStart ) {
				i = nEntryID[nBtn-bStart+nStart];
				szTagText[i] = wnd_fgets(nBtn,64,0x44e,szTagText[i]);
				wnd_ftext(nBtn,prints("%-64s",szTagText[i]),nTatrb);
				nEdited = 1;
			}
			continue;
		}
		break;
	}
	wndclose();
}

void	UpdEntryDlg(int nStart)
{
	int	i, j;

	for(i=0;i<MAXITEM;i++) {
		j = i + nStart;
		if ( j >= nEntry ) break;
		wnd_ftext(bStart+i,prints("%-64s",szTagText[nEntryID[j]]),nTatrb);
	}

}

void	OpenEntryDlg(int nStart)
{
	int	nWnd[]={4,24,4,72,0x3270};
	int	rBase, cBase;
	int	idx;
	int	i, j;

	wndopen(nWnd,szText[29]/*"TBX Tag Attribute Entry Setup"*/,0x3f1f,0x8000);

	rBase = nWnd[1]-nWnd[0]-3;
	bOkEntry   = WndButton(rBase,4,0x108,szBtn[0]/*"&Ok"*/);
	bLast = bNext = -1;
	if ( nStart ) bLast = WndButton(rBase,20,0x108,szBtn[10]/*"&Previous"*/);
	if ( (nStart+MAXITEM)< nEntry )
		      bNext = WndButton(rBase,32,0x108,szBtn[11]/*"&Next"*/);
	rBase = 0x0400;
	cBase = 2;

	for(i=0;i<MAXITEM;i++) {
		j = i + nStart;
		if ( j >= nEntry ) break;
		idx = nTagID[nEntryID[j]];
		WndGroup(rBase,cBase,64,1,szTagPrompt[idx],nSatrb);
		rBase += 0x0001;
		j = WndEntry(rBase,cBase,"",0x140,0);
		rBase += 0x0801;
		if ( i == 0 ) bStart = j;
	}
}

char	szAsciiText[][60]={	    // Default English Display Text
/*  0 */   "Paper Frame Creation Setup",
/*  1 */   "Paper Dimensions",
/*  2 */   "Standard: ",
/*  3 */   "Paper: ",
/*  4 */   "Size: ",
/*  5 */   "Frame Setup",
/*  6 */   "Margin",
/*  7 */   "  Left: ",
/*  8 */   "   Top: ",
/*  9 */   " Right: ",
/* 10 */   "Bottom: ",
/* 11 */   "Border",
/* 12 */   " Single Line",
/* 13 */   " Double Lines",
/* 14 */   "1'st Width: ",
/* 15 */   "   Pivot: ",
/* 16 */   "Frame Scale: ",
/* 17 */   " Add Marker",
/* 18 */   "Text Height: ",
/* 19 */   "Horizontal Partition Markers",
/* 20 */   "Numbers",
/* 21 */   "Alphabets",
/* 22 */   "Div.#: ",
/* 23 */   "Vertical Partition Markers",
/* 24 */   "Preview",
/* 25 */   "TBX Setup",
/* 26 */   " Apply Selected TBX",
/* 27 */   "Scale: ",
/* 28 */   "Gap: ",
/* 29 */   "TBX Tag Attribute Entry Setup",
/* 30 */   "\nSearching for all TBX files...",
/* 31 */   " Ok, %d found.",
/* 32 */   "\nTBX -- ##Syntax error #%d at line %d: '%s'",
/* 33 */   "\nTBX -- ##Syntax error #%d at line %d, Missing '%s'",
/* 34 */   "\nTBX -- ##Reference to undefined BOX name: '%s' at line %d",
/* 35 */   "\nTBX -- ##Reference to undefined FIELD name: '%s' at line %d",
/* 36 */   "\nDDFRAME -- ## Can not open file: '%s'",
/* 37 */   "\nLoading TBX file: '%s' ...",
/* 38 */   "Paper changed and current TBX has conditional clause...",
/* 39 */   "Reload it to resolve the paper condition ?",
/* 40 */   " Create Block",
/* 41 */   "   Frame Location: ",
/* 42 */   "\nDesignate paper frame base position: ",
};

char	szBig5Text[][60]={	   // Default Chinese Big-5 Display Text
/*  0 */   "wȹϮئ۰øϳ]w",
/*  1 */   "ϥιϯȤؤo",
/*  2 */   "ϯȼз: ",
/*  3 */   " ί: ",
/*  4 */   "ؤo: ",
/*  5 */   "Ϯؼ˦]w",
/*  6 */   "دd",
/*  7 */   "  : ",
/*  8 */   "  W: ",
/*  9 */   "  k: ",
/* 10 */   "  : ",
/* 11 */   "ؽu",
/* 12 */   " uøX",
/* 13 */   " uøX",
/* 14 */   "  Due: ",
/* 15 */   "ϯȰ: ",
/* 16 */   " ϮY: ",
/* 17 */   "[϶Х",
/* 18 */   "   Хܦr: ",
/* 19 */   "VϼХܳ]w",
/* 20 */   "Ʀr   ",
/* 21 */   "jgr ",
/* 22 */   " ϼ: ",
/* 23 */   "VϼХܳ]w",
/* 24 */   "Ϯعw",
/* 25 */   "TBX w]",
/* 26 */   " ϥΩUTBXw]",
/* 27 */   ": ",
/* 28 */   " : ",
/* 29 */   "TBX ñe]w",
/* 30 */   "\n۰ʷjMҦ TBX ...",
/* 31 */   "\n, @ %d .",
/* 32 */   "\nTBX -- ## yk~ #%d  %d B: '%s'",
/* 33 */   "\nTBX -- ## yk~ #%d  %d B, ʤF '%s'",
/* 34 */   "\nTBX -- ## ٨|wq BOX W: '%s'  %d B.",
/* 35 */   "\nTBX -- ## ٨|wq FIELD W: '%s'  %d B.",
/* 36 */   "\nDDFRAME -- ## Lk}ɮ: '%s'",
/* 37 */   "\nbŪ TBX : '%s' ...",
/* 38 */   "ȱiBҫwTBXtly...",
/* 39 */   "ݭTBXɥHBzȱi󤣦PB, Tw?",
/* 40 */   " ͹ϲյG",
/* 41 */   "     Ϯذ򥻦m: ",
/* 42 */   "\nЫwϮئmI: ",
};

char	szGB2312Text[][60]={	// Default Chinese GB2312 Display Text
/*  0 */   "ֽͼԶͼ趨",
/*  1 */   "ʹͼֽߴ",
/*  2 */   "ͼֽ׼: ",
/*  3 */   " ֽ: ",
/*  4 */   "ߴ: ",
/*  5 */   "ͼʽ趨",
/*  6 */   "߿",
/*  7 */   "  : ",
/*  8 */   "  ϱ: ",
/*  9 */   "  ұ: ",
/* 10 */   "  ױ: ",
/* 11 */   "",
/* 12 */   " ߻",
/* 13 */   " ˫߻",
/* 14 */   "  ߿: ",
/* 15 */   "ͼֽ׼: ",
/* 16 */   "ͼű: ",
/* 17 */   "ʾ",
/* 18 */   "   ʾָ: ",
/* 19 */   "ˮƽʾ趨",
/* 20 */   "   ",
/* 21 */   "дĸ ",
/* 22 */   " : ",
/* 23 */   "ֱʾ趨",
/* 24 */   "ͼԤ",
/* 25 */   "TBX Ԥλ",
/* 26 */   " ʹõµTBXԤλ",
/* 27 */   ": ",
/* 28 */   "϶: ",
/* 29 */   "TBX ǩ趨",
/* 30 */   "\nԶѰе TBX ...",
/* 31 */   "\n, ҵ %d .",
/* 32 */   "\nTBX -- ## ﷨ #%d  %d : '%s'",
/* 33 */   "\nTBX -- ## ﷨ #%d  %d , ȱ '%s'",
/* 34 */   "\nTBX -- ## ָƵδ BOX : '%s'  %d .",
/* 35 */   "\nTBX -- ## ָƵδ FIELD : '%s'  %d .",
/* 36 */   "\nDDFRAME -- ## ޷: '%s'",
/* 37 */   "\nڶȡ TBX : '%s' ...",
/* 38 */   "ֽŸָ֮TBXӾ...",
/* 39 */   "TBXԴֽ֮ͬ, ȷ?",
/* 40 */   " ͼ",
/* 41 */   "     ͼλ: ",
/* 42 */   "\nָͼλû׼: ",
};
//
//	The following Japenese messages are translated by _____________.
//
char	szSJISText[][60]={    // Default Japenese SJIS Display Text
/*  0 */   "}ʘg̐ݒ",
/*  1 */   "p̐@",
/*  2 */   "WKi: ",
/*  3 */   "p: ",
/*  4 */   "TCY: ",
/*  5 */   "g̐ݒ",
/*  6 */   "}[W",
/*  7 */   " : ",
/*  8 */   " : ",
/*  9 */   " E: ",
/* 10 */   " : ",
/* 11 */   "E",
/* 12 */   "P{̐",
/* 13 */   "Q{̐",
/* 14 */   "֊s" ,//
/* 15 */   "ْfϰ",//pivot
/* 16 */   "ڰсE: ",
/* 17 */   "敪L",
/* 18 */   "̍: ",
/* 19 */   "̋敪",
/* 20 */   "l",
/* 21 */   "p",
/* 22 */   ": ",
/* 23 */   "̋敪",
/* 24 */   "ޭ",
/* 25 */   "TBX ݒ",
/* 26 */   "TBX ̒",
/* 27 */   "r",
/* 28 */   "ެ",
/* 29 */   "TBX ^O̐ݒ",
/* 30 */   "\nSĂ TBX t@Č",
/* 31 */   "\nOk, %d L܂B",
/* 32 */   "\nTBX -- ##@G[ #%d %d@s: '%s'",
/* 33 */   "\nTBX -- ##@G[ #%d %d@s: '%s'Ȃ",
/* 34 */   "\nTBX -- ##` BOX : '%s'  %d@s",
/* 35 */   "\nTBX -- ##` FIELD : '%s' %d@s",
/* 36 */   "\nDDFRAME -- ## t@CI[vo܂B '%s'",
/* 37 */   "\nTBX t@C@'%s' [h ...",
/* 38 */   "w肳ꂽ TBX ̗pɌĉB",
/* 39 */   "Reload it to resolve the paper condition ?",
/* 40 */   "ۯ쐬",
/* 41 */   "ڰсE۹ ",
/* 42 */   "\nڰт̌_̈ʒuw肵ĉ: ",
};
//
//	The following Korean messages are translated by _____________.
//
char	szKoreanText[][60]={	// Default Korean Display Text
/*  0 */   "Paper Frame Setup",
/*  1 */   "Paper Dimensions",
/*  2 */   "Standard: ",
/*  3 */   "Paper: ",
/*  4 */   "Size: ",
/*  5 */   "Frame Setup",
/*  6 */   "Margin",
/*  7 */   "  Left: ",
/*  8 */   "   Top: ",
/*  9 */   " Right: ",
/* 10 */   "Bottom: ",
/* 11 */   "Border",
/* 12 */   " Single Line",
/* 13 */   " Double Lines",
/* 14 */   "1'st Width: ",
/* 15 */   "   Pivot: ",
/* 16 */   "Frame Scale: ",
/* 17 */   " Add Marker",
/* 18 */   "Text Height: ",
/* 19 */   "Horizontal Partition Markers",
/* 20 */   "Numbers",
/* 21 */   "Alphabets",
/* 22 */   "Div.#: ",
/* 23 */   "Vertical Partition Markers",
/* 24 */   "Preview",
/* 25 */   "TBX Setup",
/* 26 */   " Apply Selected TBX",
/* 27 */   "Scale: ",
/* 28 */   "Gap: ",
/* 29 */   "TBX Tag Attribute Entry Setup",
/* 30 */   "\nSearching for all TBX files...",
/* 31 */   "\nOk, %d found.",
/* 32 */   "\nTBX -- ##Syntax error #%d at line %d: '%s'",
/* 33 */   "\nTBX -- ##Syntax error #%d at line %d, Missing '%s'",
/* 34 */   "\nTBX -- ##Reference to undefined BOX name: '%s' at line %d",
/* 35 */   "\nTBX -- ##Reference to undefined FIELD name: '%s' at line %d",
/* 36 */   "\nDDFRAME -- ## Can not open file: '%s'",
/* 37 */   "\nLoading TBX file: '%s' ...",
/* 38 */   "Paper changed and current TBX has conditional clause...",
/* 39 */   "Reload it to resolve the paper condition ?",
/* 40 */   " Create Block",
/* 41 */   "   Frame Location: ",
/* 42 */   "\nDesignate paper frame base position: ",
};

char	szAsciiBtn[][10]={	   // Default English Display Text
/*  0 */   "&OK",
/*  1 */   "&Cancel",
/*  2 */   "&Help",
/*  3 */   "&Quit",
/*  4 */   "&Create",
/*  5 */   "&Modify",
/*  6 */   "Sam&ple",
/*  7 */   "Pre&view",
/*  8 */   "&TagEdit",
/*  9 */   "&Default",
/* 10 */   "&Previous",
/* 11 */   "&Next",
};

char	szBig5Btn[][10]={	  // Default English Display Text
/*  0 */   "Tw[&O]",
/*  1 */   "[&C]",
/*  2 */   "[&H]",
/*  3 */   "hX[&Q]",
/*  4 */   "Ы[&C]",
/*  5 */   "[&M]",
/*  6 */   "ѷ[&P]",
/*  7 */   "w[&V]",
/*  8 */   "e[&T]",
/*  9 */   "w][&D]",
/* 10 */   "e[&P]",
/* 11 */   "[&N]",
};

char	szGB2312Btn[][10]={	    // Default English Display Text
/*  0 */   "ȷ[&O]",
/*  1 */   "ȡ[&C]",
/*  2 */   "˵[&H]",
/*  3 */   "˳[&Q]",
/*  4 */   "[&C]",
/*  5 */   "[&M]",
/*  6 */   "[&P]",
/*  7 */   "Ԥ[&V]",
/*  8 */   "[&T]",
/*  9 */   "Ԥ[&D]",
/* 10 */   "ǰҳ[&P]",
/* 11 */   "ҳ[&N]",
};

char	szSJISBtn[][10]={	  // Default English Display Text
/*  0 */   "&OK",
/*  1 */   "ݾ[&C]",
/*  2 */   "[&H]",
/*  3 */   "I[&Q]",
/*  4 */   "쐬[&C]",
/*  5 */   "C[&M]",
/*  6 */   "[&P]",
/*  7 */   "\\[&V]",
/*  8 */   " ޕҏW",
/*  9 */   " ̫ ",
/* 10 */   "   O   ",
/* 11 */   "      ",
};

char	szKoreanBtn[][10]={	    // Default English Display Text
/*  0 */   "&OK",
/*  1 */   "&Cancel",
/*  2 */   "&Help",
/*  3 */   "&Quit",
/*  4 */   "&Create",
/*  5 */   "&Modify",
/*  6 */   "Sam&ple",
/*  7 */   "Pre&view",
/*  8 */   "&TagEdit",
/*  9 */   "&Default",
/* 10 */   "&Previous",
/* 11 */   "&Next",
};

char	szDOSAsciiBtn[][10]={	      // Default English Display Text
/*  0 */   "   OK   ",
/*  1 */   " Cancel ",
/*  2 */   "  Help  ",
/*  3 */   "  Quit  ",
/*  4 */   " Create ",
/*  5 */   " Modify ",
/*  6 */   " Sample ",
/*  7 */   " Preview",
/*  8 */   " TagEdit",
/*  9 */   " Default",
/* 10 */   "Previous",
/* 11 */   "  Next  ",
};

char	szDOSBig5Btn[][10]={	     // Default English Display Text
/*  0 */   "  Tw  ",
/*  1 */   "    ",
/*  2 */   "    ",
/*  3 */   "  hX  ",
/*  4 */   "  Ы  ",
/*  5 */   "    ",
/*  6 */   "  ѷ  ",
/*  7 */   "  w  ",
/*  8 */   "  e  ",
/*  9 */   "  w]  ",
/* 10 */   "  e  ",
/* 11 */   "    ",
};

char	szDOSGB2312Btn[][10]={	     // Default English Display Text
/*  0 */   "  ȷ  ",
/*  1 */   "  ȡ  ",
/*  2 */   "  ˵  ",
/*  3 */   "  ˳  ",
/*  4 */   "    ",
/*  5 */   "    ",
/*  6 */   "    ",
/*  7 */   "  Ԥ  ",
/*  8 */   "    ",
/*  9 */   "  Ԥ  ",
/* 10 */   "  ǰҳ  ",
/* 11 */   "  ҳ  ",
};

char	szDOSSJISBtn[][10]={	     // Default English Display Text
/*  0 */   "   OK   ",
/*  1 */   " ݾ  ",
/*  2 */   "    ",
/*  3 */   "  I  ",
/*  4 */   "  쐬  ",
/*  5 */   "  C  ",
/*  6 */   "   ",
/*  7 */   "  \\  ",
/*  8 */   " ޕҏW",
/*  9 */   " ̫ ",
/* 10 */   "   O   ",
/* 11 */   "      ",
};

char	szDOSKoreanBtn[][10]={	       // Default English Display Text
/*  0 */   "   OK   ",
/*  1 */   " Cancel ",
/*  2 */   "  Help  ",
/*  3 */   "  Quit  ",
/*  4 */   " Create ",
/*  5 */   " Modify ",
/*  6 */   " Sample ",
/*  7 */   " Preview",
/*  8 */   " TagEdit",
/*  9 */   " Default",
/* 10 */   "Previous",
/* 11 */   "  Next  ",
};

#define TGBIG5		1
#define TGGB2312	2
#define TGSJIS		5
#define TGKOREAN	3

int	SetMsgText()
{
	char	szBuf[80];
	int	switched;

	IsWin = 1;
	switch(1) {  // Test if we are in TwinCAD ...
	  case !identify("os_type"):
	  case (os_type()<0):	// Must be in DOS version!
		IsWin = 0;
		break;
	}

	if ( IsWin ) {
	    szBuf = get_profile("General Setup","AlternateLanguage");
	    switched = 0;
	    if ( szBuf!="" )
		switched = eval(szBuf);
	    setdata(szText,szAsciiText);
	    setdata(szBtn,szAsciiBtn);
	    if ( switched ) {
		switch(os_language()) {
		  case BIG5:	setdata(szText,szBig5Text);	break;
		  case GB2312:	setdata(szText,szGB2312Text);	break;
		  case SJIS:	setdata(szText,szSJISText);	break;
		  case KOREAN:	setdata(szText,szKoreanText);	break;
		  default:	setdata(szText,szAsciiText);	break;
		}
		switch(os_language()) {
		  case BIG5:	setdata(szBtn,szBig5Btn);     break;
		  case GB2312:	setdata(szBtn,szGB2312Btn);   break;
		  case SJIS:	setdata(szBtn,szSJISBtn);     break;
		  case KOREAN:	setdata(szBtn,szKoreanBtn);   break;
		  default:	setdata(szBtn,szAsciiBtn);    break;
		}
	    }
	}
	else {	// Switched or not, depends on TGF type in DOS version
	    setdata(szText,szAsciiText);
	    setdata(szBtn,szDOSAsciiBtn);
	    switch(@tgftype) {
	      case TGBIG5:    setdata(szText,szBig5Text);     break;
	      case TGGB2312:  setdata(szText,szGB2312Text);   break;
	      case TGSJIS:    setdata(szText,szSJISText);     break;
	      case TGKOREAN:  setdata(szText,szKoreanText);   break;
	      default:	      setdata(szText,szAsciiText);    break;
	    }
	    switch(@tgftype) {
	      case TGBIG5:    setdata(szBtn,szDOSBig5Btn);     break;
	      case TGGB2312:  setdata(szBtn,szDOSGB2312Btn);   break;
	      case TGSJIS:    setdata(szBtn,szDOSSJISBtn);     break;
	      case TGKOREAN:  setdata(szBtn,szDOSKoreanBtn);   break;
	      default:	      setdata(szBtn,szDOSAsciiBtn);    break;
	    }
	}
	return 0;
}
//
//	End of this Program file
//
